{-----------------------------------------------------------------------------}
{                                                                             }
{                                CUJ$ Routines                                }
{                                    v4.8                                     }
{                                 Written by                                  }
{                               Steven C. King                                }
{                            stuking@acs.eku.edu                              }
{                                   (Cujo)                                    }
{                            Copyright 1993, 1994                             }
{                        Created on September 1, 1991                         }
{                         Revised on March 24, 1994                           }
{                                                                             }
{   This module provides some nifty ways to use RTL and system service rou-   }
{ tines.  Please send any updates, questions, or comments to STUKING@acs.eku. }
{ edu.  To compile this module, type the following line:                      }
{                                                                             }
{                              PASCAL$/NODEBUG CUJ                            }
{                                                                             }
{ Once compiled, you can inherit and link this module with your program(s).   }
{ Some routines are still being updated, so don't be surprised if some of     }
{ them appear incomplete or are not working properly.                         }
{                                                                             }
{-----------------------------------------------------------------------------}

[Environment, Optimize(All), Inherit('Sys$Library:Starlet', 'Sys$Library:Pascal$Smg_Routines', 'Sys$Library:Pascal$Lib_Routines')]

{-----------------------------------------------------------------------------}

MODULE Cuj$Routines;

{-----------------------------------------------------------------------------}

CONST
  Cuj$Escape             = Chr(27);
  Cuj$Cursor_On          = Chr(27)+'[?25h';
  Cuj$Cursor_Off         = Chr(27)+'[?25l';
  Cuj$Bold               = Chr(27)+'[1m';
  Cuj$Blink              = Chr(27)+'[5m';
  Cuj$Reverse            = Chr(27)+'[7m';
  Cuj$Restore            = Chr(27)+'[0m';
  Cuj$Disable_Mask       = %b'00000010000000001000000000001000';
  Cuj$Enable_Mask        = %b'00000000000000000000000000000000';
  Cuj$Ctrl_Space         = 0;
  Cuj$Ctrl_A             = 1;
  Cuj$Ctrl_B             = 2;
  Cuj$Ctrl_C             = 3;
  Cuj$Ctrl_D             = 4;
  Cuj$Ctrl_E             = 5;
  Cuj$Ctrl_F             = 6;
  Cuj$Ctrl_G             = 7;
  Cuj$Ctrl_H             = 8;
  Cuj$Ctrl_I             = 9;
  Cuj$Tab                = 9;
  Cuj$Ctrl_J             = 10;
  Cuj$Ctrl_K             = 11;
  Cuj$Ctrl_L             = 12;
  Cuj$Ctrl_M             = 13;
  Cuj$Return             = 13;
  Cuj$Ctrl_N             = 14;
  Cuj$Ctrl_O             = 15;
  Cuj$Ctrl_P             = 16;
  Cuj$Ctrl_R             = 18;
  Cuj$Ctrl_T             = 20;
  Cuj$Ctrl_U             = 21;
  Cuj$Ctrl_V             = 22;
  Cuj$Ctrl_W             = 23;
  Cuj$Ctrl_X             = 24;
  Cuj$Ctrl_Y             = 25;
  Cuj$Ctrl_Z             = 26;
  Cuj$Space              = 32;
  Cuj$Upcase_A           = 65;
  Cuj$Upcase_B           = 66;
  Cuj$Upcase_C           = 67;
  Cuj$Upcase_D           = 68;
  Cuj$Upcase_E           = 69;
  Cuj$Upcase_F           = 70;
  Cuj$Upcase_G           = 71;
  Cuj$Upcase_H           = 72;
  Cuj$Upcase_I           = 73;
  Cuj$Upcase_J           = 74;
  Cuj$Upcase_K           = 75;
  Cuj$Upcase_L           = 76;
  Cuj$Upcase_M           = 77;
  Cuj$Upcase_N           = 78;
  Cuj$Upcase_O           = 79;
  Cuj$Upcase_P           = 80;
  Cuj$Upcase_Q           = 81;
  Cuj$Upcase_R           = 82;
  Cuj$Upcase_S           = 83;
  Cuj$Upcase_T           = 84;
  Cuj$Upcase_U           = 85;
  Cuj$Upcase_V           = 86;
  Cuj$Upcase_W           = 87;
  Cuj$Upcase_X           = 88;
  Cuj$Upcase_Y           = 89;
  Cuj$Upcase_Z           = 90;
  Cuj$Lowcase_A          = 97;
  Cuj$Lowcase_B          = 98;
  Cuj$Lowcase_C          = 99;
  Cuj$Lowcase_D          = 100;
  Cuj$Lowcase_E          = 101;
  Cuj$Lowcase_F          = 102;
  Cuj$Lowcase_G          = 103;
  Cuj$Lowcase_H          = 104;
  Cuj$Lowcase_I          = 105;
  Cuj$Lowcase_J          = 106;
  Cuj$Lowcase_K          = 107;
  Cuj$Lowcase_L          = 108;
  Cuj$Lowcase_M          = 109;
  Cuj$Lowcase_N          = 110;
  Cuj$Lowcase_O          = 111;
  Cuj$Lowcase_P          = 112;
  Cuj$Lowcase_Q          = 113;
  Cuj$Lowcase_R          = 114;
  Cuj$Lowcase_S          = 115;
  Cuj$Lowcase_T          = 116;
  Cuj$Lowcase_U          = 117;
  Cuj$Lowcase_V          = 118;
  Cuj$Lowcase_W          = 119;
  Cuj$Lowcase_X          = 120;
  Cuj$Lowcase_Y          = 121;
  Cuj$Lowcase_Z          = 122;
  Cuj$Delete             = 127;
  Cuj$Pf1                = 256;
  Cuj$Pf2                = 257;
  Cuj$Pf3                = 258;
  Cuj$Pf4                = 259;
  Cuj$Kp1                = 261;
  Cuj$Kp2                = 262;
  Cuj$Kp3                = 263;
  Cuj$Kp4                = 264;
  Cuj$Kp5                = 265;
  Cuj$Kp6                = 266;
  Cuj$Kp7                = 267;
  Cuj$Kp8                = 268;
  Cuj$Kp9                = 269;
  Cuj$Enter              = 270;
  Cuj$Up_Arrow           = 274;
  Cuj$Down_Arrow         = 275;
  Cuj$Left_Arrow         = 276;
  Cuj$Right_Arrow        = 277;
  Cuj$Help               = 295;
  Cuj$DO                 = 296;
  Cuj$Find               = 311;
  Cuj$Insert             = 312;
  Cuj$Remove             = 313;
  Cuj$Select             = 314;
  Cuj$Prev_Scrn          = 315;
  Cuj$Next_Scrn          = 316;
  Cuj$C_Encrypt          = 0;
  Cuj$C_Decrypt          = 1;
  Cuj$C_Insert           = 0;
  Cuj$C_Overstrike       = 1;
  Cuj$C_Edt              = 0;
  Cuj$C_Tpu              = 1;
  Cuj$C_Enable           = 0;
  Cuj$C_Disable          = 1;
  Cuj$C_Toggle           = 2;
  Cuj$C_Collapse         = 1;
  Cuj$C_Compress         = 2;
  Cuj$C_Lowercase        = 4;
  Cuj$C_Trim             = 8;
  Cuj$C_Uncomment        = 16;
  Cuj$C_Upcase           = 32;
  Cuj$C_Exceed           = 64;
  Cuj$C_Ascii            = 64;
  Cuj$C_Trim_Leading     = 128;
  Cuj$C_Trim_Trailing    = 256;
  Cuj$C_Left             = 0;
  Cuj$C_Right            = 1;
  Cuj$C_Normal           = 0;
  Cuj$C_Wait             = 1;
  Cuj$C_Center           = 1;
  Cuj$C_Center_Row       = 2;
  Cuj$C_Center_Column    = 4;
  Cuj$C_Right_Flush      = 8;
  Cuj$C_Backwards        = 16;
  Cuj$C_Update           = 16;
  Cuj$C_Vertical         = 32;
  Cuj$C_Block            = 64;
  Cuj$C_80_Columns       = 64;
  Cuj$C_132_Columns      = 128;
  Cuj$C_Horizontal       = 128;
  Cuj$C_Fixed            = 256;
  Cuj$C_Wrap             = 512;
  Cuj$C_90_Degrees       = 90;
  Cuj$C_180_Degrees      = 180;
  Cuj$C_Filename         = 1;
  Cuj$C_Directory        = 2;
  Cuj$C_Local            = 0;
  Cuj$C_Bitnet           = 1;
  Cuj$C_Decnet           = 2;
  Cuj$C_System           = 3;
  Cuj$C_Mail             = 4;
  Cuj$C_User             = 5;
  Cuj$C_Talk             = 6;
  Cuj$C_Unknown          = 7;
  Cuj$T_Process          = 'LNM$PROCESS';
  Cuj$T_Job              = 'LNM$JOB';
  Cuj$T_Group            = 'LNM$GROUP';
  Cuj$T_System           = 'LNM$SYSTEM';
  Cuj$T_All              = 'LNM$DCL_LOGICAL';
  Cuj$C_Keyword          = 'KEYWORD FOR ENCRYPTION/DECRYPTION';

{-----------------------------------------------------------------------------}

TYPE
  Cuj$Varying1      = VARYING [1] OF Char;
  Cuj$Varying2      = VARYING [2] OF Char;
  Cuj$Varying3      = VARYING [3] OF Char;
  Cuj$Varying4      = VARYING [4] OF Char;
  Cuj$Varying5      = VARYING [5] OF Char;
  Cuj$Varying6      = VARYING [6] OF Char;
  Cuj$Varying7      = VARYING [7] OF Char;
  Cuj$Varying8      = VARYING [8] OF Char;
  Cuj$Varying9      = VARYING [9] OF Char;
  Cuj$Varying10     = VARYING [10] OF Char;
  Cuj$Varying11     = VARYING [11] OF Char;
  Cuj$Varying12     = VARYING [12] OF Char;
  Cuj$Varying13     = VARYING [13] OF Char;
  Cuj$Varying14     = VARYING [14] OF Char;
  Cuj$Varying15     = VARYING [15] OF Char;
  Cuj$Varying16     = VARYING [16] OF Char;
  Cuj$Varying17     = VARYING [17] OF Char;
  Cuj$Varying18     = VARYING [18] OF Char;
  Cuj$Varying19     = VARYING [19] OF Char;
  Cuj$Varying20     = VARYING [20] OF Char;
  Cuj$Varying21     = VARYING [21] OF Char;
  Cuj$Varying22     = VARYING [22] OF Char;
  Cuj$Varying23     = VARYING [23] OF Char;
  Cuj$Varying24     = VARYING [24] OF Char;
  Cuj$Varying25     = VARYING [25] OF Char;
  Cuj$Varying26     = VARYING [26] OF Char;
  Cuj$Varying27     = VARYING [27] OF Char;
  Cuj$Varying28     = VARYING [28] OF Char;
  Cuj$Varying29     = VARYING [29] OF Char;
  Cuj$Varying30     = VARYING [30] OF Char;
  Cuj$Varying31     = VARYING [31] OF Char;
  Cuj$Varying32     = VARYING [32] OF Char;
  Cuj$Varying33     = VARYING [33] OF Char;
  Cuj$Varying34     = VARYING [34] OF Char;
  Cuj$Varying35     = VARYING [35] OF Char;
  Cuj$Varying36     = VARYING [36] OF Char;
  Cuj$Varying37     = VARYING [37] OF Char;
  Cuj$Varying38     = VARYING [38] OF Char;
  Cuj$Varying39     = VARYING [39] OF Char;
  Cuj$Varying40     = VARYING [40] OF Char;
  Cuj$Varying41     = VARYING [41] OF Char;
  Cuj$Varying42     = VARYING [42] OF Char;
  Cuj$Varying43     = VARYING [43] OF Char;
  Cuj$Varying44     = VARYING [44] OF Char;
  Cuj$Varying45     = VARYING [45] OF Char;
  Cuj$Varying46     = VARYING [46] OF Char;
  Cuj$Varying47     = VARYING [47] OF Char;
  Cuj$Varying48     = VARYING [48] OF Char;
  Cuj$Varying49     = VARYING [49] OF Char;
  Cuj$Varying50     = VARYING [50] OF Char;
  Cuj$Varying51     = VARYING [51] OF Char;
  Cuj$Varying52     = VARYING [52] OF Char;
  Cuj$Varying53     = VARYING [53] OF Char;
  Cuj$Varying54     = VARYING [54] OF Char;
  Cuj$Varying55     = VARYING [55] OF Char;
  Cuj$Varying56     = VARYING [56] OF Char;
  Cuj$Varying57     = VARYING [57] OF Char;
  Cuj$Varying58     = VARYING [58] OF Char;
  Cuj$Varying59     = VARYING [59] OF Char;
  Cuj$Varying60     = VARYING [60] OF Char;
  Cuj$Varying61     = VARYING [61] OF Char;
  Cuj$Varying62     = VARYING [62] OF Char;
  Cuj$Varying63     = VARYING [63] OF Char;
  Cuj$Varying64     = VARYING [64] OF Char;
  Cuj$Varying65     = VARYING [65] OF Char;
  Cuj$Varying66     = VARYING [66] OF Char;
  Cuj$Varying67     = VARYING [67] OF Char;
  Cuj$Varying68     = VARYING [68] OF Char;
  Cuj$Varying69     = VARYING [69] OF Char;
  Cuj$Varying70     = VARYING [70] OF Char;
  Cuj$Varying71     = VARYING [71] OF Char;
  Cuj$Varying72     = VARYING [72] OF Char;
  Cuj$Varying73     = VARYING [73] OF Char;
  Cuj$Varying74     = VARYING [74] OF Char;
  Cuj$Varying75     = VARYING [75] OF Char;
  Cuj$Varying76     = VARYING [76] OF Char;
  Cuj$Varying77     = VARYING [77] OF Char;
  Cuj$Varying78     = VARYING [78] OF Char;
  Cuj$Varying79     = VARYING [79] OF Char;
  Cuj$Varying80     = VARYING [80] OF Char;
  Cuj$Varying81     = VARYING [81] OF Char;
  Cuj$Varying82     = VARYING [82] OF Char;
  Cuj$Varying83     = VARYING [83] OF Char;
  Cuj$Varying84     = VARYING [84] OF Char;
  Cuj$Varying85     = VARYING [85] OF Char;
  Cuj$Varying86     = VARYING [86] OF Char;
  Cuj$Varying87     = VARYING [87] OF Char;
  Cuj$Varying88     = VARYING [88] OF Char;
  Cuj$Varying89     = VARYING [89] OF Char;
  Cuj$Varying90     = VARYING [90] OF Char;
  Cuj$Varying91     = VARYING [91] OF Char;
  Cuj$Varying92     = VARYING [92] OF Char;
  Cuj$Varying93     = VARYING [93] OF Char;
  Cuj$Varying94     = VARYING [94] OF Char;
  Cuj$Varying95     = VARYING [95] OF Char;
  Cuj$Varying96     = VARYING [96] OF Char;
  Cuj$Varying97     = VARYING [97] OF Char;
  Cuj$Varying98     = VARYING [98] OF Char;
  Cuj$Varying99     = VARYING [99] OF Char;
  Cuj$Varying100    = VARYING [100] OF Char;
  Cuj$Varying101    = VARYING [101] OF Char;
  Cuj$Varying102    = VARYING [102] OF Char;
  Cuj$Varying103    = VARYING [103] OF Char;
  Cuj$Varying104    = VARYING [104] OF Char;
  Cuj$Varying105    = VARYING [105] OF Char;
  Cuj$Varying106    = VARYING [106] OF Char;
  Cuj$Varying107    = VARYING [107] OF Char;
  Cuj$Varying108    = VARYING [108] OF Char;
  Cuj$Varying109    = VARYING [109] OF Char;
  Cuj$Varying110    = VARYING [110] OF Char;
  Cuj$Varying111    = VARYING [111] OF Char;
  Cuj$Varying112    = VARYING [112] OF Char;
  Cuj$Varying113    = VARYING [113] OF Char;
  Cuj$Varying114    = VARYING [114] OF Char;
  Cuj$Varying115    = VARYING [115] OF Char;
  Cuj$Varying116    = VARYING [116] OF Char;
  Cuj$Varying117    = VARYING [117] OF Char;
  Cuj$Varying118    = VARYING [118] OF Char;
  Cuj$Varying119    = VARYING [119] OF Char;
  Cuj$Varying120    = VARYING [120] OF Char;
  Cuj$Varying121    = VARYING [121] OF Char;
  Cuj$Varying122    = VARYING [122] OF Char;
  Cuj$Varying123    = VARYING [123] OF Char;
  Cuj$Varying124    = VARYING [124] OF Char;
  Cuj$Varying125    = VARYING [125] OF Char;
  Cuj$Varying126    = VARYING [126] OF Char;
  Cuj$Varying127    = VARYING [127] OF Char;
  Cuj$Varying128    = VARYING [128] OF Char;
  Cuj$Varying129    = VARYING [129] OF Char;
  Cuj$Varying130    = VARYING [130] OF Char;
  Cuj$Varying131    = VARYING [131] OF Char;
  Cuj$Varying132    = VARYING [132] OF Char;
  Cuj$Varying133    = VARYING [133] OF Char;
  Cuj$Varying134    = VARYING [134] OF Char;
  Cuj$Varying135    = VARYING [135] OF Char;
  Cuj$Varying136    = VARYING [136] OF Char;
  Cuj$Varying137    = VARYING [137] OF Char;
  Cuj$Varying138    = VARYING [138] OF Char;
  Cuj$Varying139    = VARYING [139] OF Char;
  Cuj$Varying140    = VARYING [140] OF Char;
  Cuj$Varying141    = VARYING [141] OF Char;
  Cuj$Varying142    = VARYING [142] OF Char;
  Cuj$Varying143    = VARYING [143] OF Char;
  Cuj$Varying144    = VARYING [144] OF Char;
  Cuj$Varying145    = VARYING [145] OF Char;
  Cuj$Varying146    = VARYING [146] OF Char;
  Cuj$Varying147    = VARYING [147] OF Char;
  Cuj$Varying148    = VARYING [148] OF Char;
  Cuj$Varying149    = VARYING [149] OF Char;
  Cuj$Varying150    = VARYING [150] OF Char;
  Cuj$Varying151    = VARYING [151] OF Char;
  Cuj$Varying152    = VARYING [152] OF Char;
  Cuj$Varying153    = VARYING [153] OF Char;
  Cuj$Varying154    = VARYING [154] OF Char;
  Cuj$Varying155    = VARYING [155] OF Char;
  Cuj$Varying156    = VARYING [156] OF Char;
  Cuj$Varying157    = VARYING [157] OF Char;
  Cuj$Varying158    = VARYING [158] OF Char;
  Cuj$Varying159    = VARYING [159] OF Char;
  Cuj$Varying160    = VARYING [160] OF Char;
  Cuj$Varying161    = VARYING [161] OF Char;
  Cuj$Varying162    = VARYING [162] OF Char;
  Cuj$Varying163    = VARYING [163] OF Char;
  Cuj$Varying164    = VARYING [164] OF Char;
  Cuj$Varying165    = VARYING [165] OF Char;
  Cuj$Varying166    = VARYING [166] OF Char;
  Cuj$Varying167    = VARYING [167] OF Char;
  Cuj$Varying168    = VARYING [168] OF Char;
  Cuj$Varying169    = VARYING [169] OF Char;
  Cuj$Varying170    = VARYING [170] OF Char;
  Cuj$Varying171    = VARYING [171] OF Char;
  Cuj$Varying172    = VARYING [172] OF Char;
  Cuj$Varying173    = VARYING [173] OF Char;
  Cuj$Varying174    = VARYING [174] OF Char;
  Cuj$Varying175    = VARYING [175] OF Char;
  Cuj$Varying176    = VARYING [176] OF Char;
  Cuj$Varying177    = VARYING [177] OF Char;
  Cuj$Varying178    = VARYING [178] OF Char;
  Cuj$Varying179    = VARYING [179] OF Char;
  Cuj$Varying180    = VARYING [180] OF Char;
  Cuj$Varying181    = VARYING [181] OF Char;
  Cuj$Varying182    = VARYING [182] OF Char;
  Cuj$Varying183    = VARYING [183] OF Char;
  Cuj$Varying184    = VARYING [184] OF Char;
  Cuj$Varying185    = VARYING [185] OF Char;
  Cuj$Varying186    = VARYING [186] OF Char;
  Cuj$Varying187    = VARYING [187] OF Char;
  Cuj$Varying188    = VARYING [188] OF Char;
  Cuj$Varying189    = VARYING [189] OF Char;
  Cuj$Varying190    = VARYING [190] OF Char;
  Cuj$Varying191    = VARYING [191] OF Char;
  Cuj$Varying192    = VARYING [192] OF Char;
  Cuj$Varying193    = VARYING [193] OF Char;
  Cuj$Varying194    = VARYING [194] OF Char;
  Cuj$Varying195    = VARYING [195] OF Char;
  Cuj$Varying196    = VARYING [196] OF Char;
  Cuj$Varying197    = VARYING [197] OF Char;
  Cuj$Varying198    = VARYING [198] OF Char;
  Cuj$Varying199    = VARYING [199] OF Char;
  Cuj$Varying200    = VARYING [200] OF Char;
  Cuj$Varying201    = VARYING [201] OF Char;
  Cuj$Varying202    = VARYING [202] OF Char;
  Cuj$Varying203    = VARYING [203] OF Char;
  Cuj$Varying204    = VARYING [204] OF Char;
  Cuj$Varying205    = VARYING [205] OF Char;
  Cuj$Varying206    = VARYING [206] OF Char;
  Cuj$Varying207    = VARYING [207] OF Char;
  Cuj$Varying208    = VARYING [208] OF Char;
  Cuj$Varying209    = VARYING [209] OF Char;
  Cuj$Varying210    = VARYING [210] OF Char;
  Cuj$Varying211    = VARYING [211] OF Char;
  Cuj$Varying212    = VARYING [212] OF Char;
  Cuj$Varying213    = VARYING [213] OF Char;
  Cuj$Varying214    = VARYING [214] OF Char;
  Cuj$Varying215    = VARYING [215] OF Char;
  Cuj$Varying216    = VARYING [216] OF Char;
  Cuj$Varying217    = VARYING [217] OF Char;
  Cuj$Varying218    = VARYING [218] OF Char;
  Cuj$Varying219    = VARYING [219] OF Char;
  Cuj$Varying220    = VARYING [220] OF Char;
  Cuj$Varying221    = VARYING [221] OF Char;
  Cuj$Varying222    = VARYING [222] OF Char;
  Cuj$Varying223    = VARYING [223] OF Char;
  Cuj$Varying224    = VARYING [224] OF Char;
  Cuj$Varying225    = VARYING [225] OF Char;
  Cuj$Varying226    = VARYING [226] OF Char;
  Cuj$Varying227    = VARYING [227] OF Char;
  Cuj$Varying228    = VARYING [228] OF Char;
  Cuj$Varying229    = VARYING [229] OF Char;
  Cuj$Varying230    = VARYING [230] OF Char;
  Cuj$Varying231    = VARYING [231] OF Char;
  Cuj$Varying232    = VARYING [232] OF Char;
  Cuj$Varying233    = VARYING [233] OF Char;
  Cuj$Varying234    = VARYING [234] OF Char;
  Cuj$Varying235    = VARYING [235] OF Char;
  Cuj$Varying236    = VARYING [236] OF Char;
  Cuj$Varying237    = VARYING [237] OF Char;
  Cuj$Varying238    = VARYING [238] OF Char;
  Cuj$Varying239    = VARYING [239] OF Char;
  Cuj$Varying240    = VARYING [240] OF Char;
  Cuj$Varying241    = VARYING [241] OF Char;
  Cuj$Varying242    = VARYING [242] OF Char;
  Cuj$Varying243    = VARYING [243] OF Char;
  Cuj$Varying244    = VARYING [244] OF Char;
  Cuj$Varying245    = VARYING [245] OF Char;
  Cuj$Varying246    = VARYING [246] OF Char;
  Cuj$Varying247    = VARYING [247] OF Char;
  Cuj$Varying248    = VARYING [248] OF Char;
  Cuj$Varying249    = VARYING [249] OF Char;
  Cuj$Varying250    = VARYING [250] OF Char;
  Cuj$Varying251    = VARYING [251] OF Char;
  Cuj$Varying252    = VARYING [252] OF Char;
  Cuj$Varying253    = VARYING [253] OF Char;
  Cuj$Varying254    = VARYING [254] OF Char;
  Cuj$Varying255    = VARYING [255] OF Char;
  Cuj$Varying256    = VARYING [256] OF Char;
  Cuj$Varying512    = VARYING [512] OF Char;
  Cuj$Varying2000   = VARYING [2000] OF Char;
  Cuj$Packed1       = PACKED ARRAY [1..1] OF Char;
  Cuj$Packed2       = PACKED ARRAY [1..2] OF Char;
  Cuj$Packed3       = PACKED ARRAY [1..3] OF Char;
  Cuj$Packed4       = PACKED ARRAY [1..4] OF Char;
  Cuj$Packed5       = PACKED ARRAY [1..5] OF Char;
  Cuj$Packed6       = PACKED ARRAY [1..6] OF Char;
  Cuj$Packed7       = PACKED ARRAY [1..7] OF Char;
  Cuj$Packed8       = PACKED ARRAY [1..8] OF Char;
  Cuj$Packed9       = PACKED ARRAY [1..9] OF Char;
  Cuj$Packed10      = PACKED ARRAY [1..10] OF Char;
  Cuj$Packed11      = PACKED ARRAY [1..11] OF Char;
  Cuj$Packed12      = PACKED ARRAY [1..12] OF Char;
  Cuj$Packed13      = PACKED ARRAY [1..13] OF Char;
  Cuj$Packed14      = PACKED ARRAY [1..14] OF Char;
  Cuj$Packed15      = PACKED ARRAY [1..15] OF Char;
  Cuj$Packed16      = PACKED ARRAY [1..16] OF Char;
  Cuj$Packed17      = PACKED ARRAY [1..17] OF Char;
  Cuj$Packed18      = PACKED ARRAY [1..18] OF Char;
  Cuj$Packed19      = PACKED ARRAY [1..19] OF Char;
  Cuj$Packed20      = PACKED ARRAY [1..20] OF Char;
  Cuj$Packed21      = PACKED ARRAY [1..21] OF Char;
  Cuj$Packed22      = PACKED ARRAY [1..22] OF Char;
  Cuj$Packed23      = PACKED ARRAY [1..23] OF Char;
  Cuj$Packed24      = PACKED ARRAY [1..24] OF Char;
  Cuj$Packed25      = PACKED ARRAY [1..25] OF Char;
  Cuj$Packed26      = PACKED ARRAY [1..26] OF Char;
  Cuj$Packed27      = PACKED ARRAY [1..27] OF Char;
  Cuj$Packed28      = PACKED ARRAY [1..28] OF Char;
  Cuj$Packed29      = PACKED ARRAY [1..29] OF Char;
  Cuj$Packed30      = PACKED ARRAY [1..30] OF Char;
  Cuj$Packed31      = PACKED ARRAY [1..31] OF Char;
  Cuj$Packed32      = PACKED ARRAY [1..32] OF Char;
  Cuj$Packed33      = PACKED ARRAY [1..33] OF Char;
  Cuj$Packed34      = PACKED ARRAY [1..34] OF Char;
  Cuj$Packed35      = PACKED ARRAY [1..35] OF Char;
  Cuj$Packed36      = PACKED ARRAY [1..36] OF Char;
  Cuj$Packed37      = PACKED ARRAY [1..37] OF Char;
  Cuj$Packed38      = PACKED ARRAY [1..38] OF Char;
  Cuj$Packed39      = PACKED ARRAY [1..39] OF Char;
  Cuj$Packed40      = PACKED ARRAY [1..40] OF Char;
  Cuj$Packed41      = PACKED ARRAY [1..41] OF Char;
  Cuj$Packed42      = PACKED ARRAY [1..42] OF Char;
  Cuj$Packed43      = PACKED ARRAY [1..43] OF Char;
  Cuj$Packed44      = PACKED ARRAY [1..44] OF Char;
  Cuj$Packed45      = PACKED ARRAY [1..45] OF Char;
  Cuj$Packed46      = PACKED ARRAY [1..46] OF Char;
  Cuj$Packed47      = PACKED ARRAY [1..47] OF Char;
  Cuj$Packed48      = PACKED ARRAY [1..48] OF Char;
  Cuj$Packed49      = PACKED ARRAY [1..49] OF Char;
  Cuj$Packed50      = PACKED ARRAY [1..50] OF Char;
  Cuj$Packed51      = PACKED ARRAY [1..51] OF Char;
  Cuj$Packed52      = PACKED ARRAY [1..52] OF Char;
  Cuj$Packed53      = PACKED ARRAY [1..53] OF Char;
  Cuj$Packed54      = PACKED ARRAY [1..54] OF Char;
  Cuj$Packed55      = PACKED ARRAY [1..55] OF Char;
  Cuj$Packed56      = PACKED ARRAY [1..56] OF Char;
  Cuj$Packed57      = PACKED ARRAY [1..57] OF Char;
  Cuj$Packed58      = PACKED ARRAY [1..58] OF Char;
  Cuj$Packed59      = PACKED ARRAY [1..59] OF Char;
  Cuj$Packed60      = PACKED ARRAY [1..60] OF Char;
  Cuj$Packed61      = PACKED ARRAY [1..61] OF Char;
  Cuj$Packed62      = PACKED ARRAY [1..62] OF Char;
  Cuj$Packed63      = PACKED ARRAY [1..63] OF Char;
  Cuj$Packed64      = PACKED ARRAY [1..64] OF Char;
  Cuj$Packed65      = PACKED ARRAY [1..65] OF Char;
  Cuj$Packed66      = PACKED ARRAY [1..66] OF Char;
  Cuj$Packed67      = PACKED ARRAY [1..67] OF Char;
  Cuj$Packed68      = PACKED ARRAY [1..68] OF Char;
  Cuj$Packed69      = PACKED ARRAY [1..69] OF Char;
  Cuj$Packed70      = PACKED ARRAY [1..70] OF Char;
  Cuj$Packed71      = PACKED ARRAY [1..71] OF Char;
  Cuj$Packed72      = PACKED ARRAY [1..72] OF Char;
  Cuj$Packed73      = PACKED ARRAY [1..73] OF Char;
  Cuj$Packed74      = PACKED ARRAY [1..74] OF Char;
  Cuj$Packed75      = PACKED ARRAY [1..75] OF Char;
  Cuj$Packed76      = PACKED ARRAY [1..76] OF Char;
  Cuj$Packed77      = PACKED ARRAY [1..77] OF Char;
  Cuj$Packed78      = PACKED ARRAY [1..78] OF Char;
  Cuj$Packed79      = PACKED ARRAY [1..79] OF Char;
  Cuj$Packed80      = PACKED ARRAY [1..80] OF Char;
  Cuj$Packed81      = PACKED ARRAY [1..81] OF Char;
  Cuj$Packed82      = PACKED ARRAY [1..82] OF Char;
  Cuj$Packed83      = PACKED ARRAY [1..83] OF Char;
  Cuj$Packed84      = PACKED ARRAY [1..84] OF Char;
  Cuj$Packed85      = PACKED ARRAY [1..85] OF Char;
  Cuj$Packed86      = PACKED ARRAY [1..86] OF Char;
  Cuj$Packed87      = PACKED ARRAY [1..87] OF Char;
  Cuj$Packed88      = PACKED ARRAY [1..88] OF Char;
  Cuj$Packed89      = PACKED ARRAY [1..89] OF Char;
  Cuj$Packed90      = PACKED ARRAY [1..90] OF Char;
  Cuj$Packed91      = PACKED ARRAY [1..91] OF Char;
  Cuj$Packed92      = PACKED ARRAY [1..92] OF Char;
  Cuj$Packed93      = PACKED ARRAY [1..93] OF Char;
  Cuj$Packed94      = PACKED ARRAY [1..94] OF Char;
  Cuj$Packed95      = PACKED ARRAY [1..95] OF Char;
  Cuj$Packed96      = PACKED ARRAY [1..96] OF Char;
  Cuj$Packed97      = PACKED ARRAY [1..97] OF Char;
  Cuj$Packed98      = PACKED ARRAY [1..98] OF Char;
  Cuj$Packed99      = PACKED ARRAY [1..99] OF Char;
  Cuj$Packed100     = PACKED ARRAY [1..100] OF Char;
  Cuj$Packed101     = PACKED ARRAY [1..101] OF Char;
  Cuj$Packed102     = PACKED ARRAY [1..102] OF Char;
  Cuj$Packed103     = PACKED ARRAY [1..103] OF Char;
  Cuj$Packed104     = PACKED ARRAY [1..104] OF Char;
  Cuj$Packed105     = PACKED ARRAY [1..105] OF Char;
  Cuj$Packed106     = PACKED ARRAY [1..106] OF Char;
  Cuj$Packed107     = PACKED ARRAY [1..107] OF Char;
  Cuj$Packed108     = PACKED ARRAY [1..108] OF Char;
  Cuj$Packed109     = PACKED ARRAY [1..109] OF Char;
  Cuj$Packed110     = PACKED ARRAY [1..110] OF Char;
  Cuj$Packed111     = PACKED ARRAY [1..111] OF Char;
  Cuj$Packed112     = PACKED ARRAY [1..112] OF Char;
  Cuj$Packed113     = PACKED ARRAY [1..113] OF Char;
  Cuj$Packed114     = PACKED ARRAY [1..114] OF Char;
  Cuj$Packed115     = PACKED ARRAY [1..115] OF Char;
  Cuj$Packed116     = PACKED ARRAY [1..116] OF Char;
  Cuj$Packed117     = PACKED ARRAY [1..117] OF Char;
  Cuj$Packed118     = PACKED ARRAY [1..118] OF Char;
  Cuj$Packed119     = PACKED ARRAY [1..119] OF Char;
  Cuj$Packed120     = PACKED ARRAY [1..120] OF Char;
  Cuj$Packed121     = PACKED ARRAY [1..121] OF Char;
  Cuj$Packed122     = PACKED ARRAY [1..122] OF Char;
  Cuj$Packed123     = PACKED ARRAY [1..123] OF Char;
  Cuj$Packed124     = PACKED ARRAY [1..124] OF Char;
  Cuj$Packed125     = PACKED ARRAY [1..125] OF Char;
  Cuj$Packed126     = PACKED ARRAY [1..126] OF Char;
  Cuj$Packed127     = PACKED ARRAY [1..127] OF Char;
  Cuj$Packed128     = PACKED ARRAY [1..128] OF Char;
  Cuj$Packed129     = PACKED ARRAY [1..129] OF Char;
  Cuj$Packed130     = PACKED ARRAY [1..130] OF Char;
  Cuj$Packed131     = PACKED ARRAY [1..131] OF Char;
  Cuj$Packed132     = PACKED ARRAY [1..132] OF Char;
  Cuj$Packed133     = PACKED ARRAY [1..133] OF Char;
  Cuj$Packed134     = PACKED ARRAY [1..134] OF Char;
  Cuj$Packed135     = PACKED ARRAY [1..135] OF Char;
  Cuj$Packed136     = PACKED ARRAY [1..136] OF Char;
  Cuj$Packed137     = PACKED ARRAY [1..137] OF Char;
  Cuj$Packed138     = PACKED ARRAY [1..138] OF Char;
  Cuj$Packed139     = PACKED ARRAY [1..139] OF Char;
  Cuj$Packed140     = PACKED ARRAY [1..140] OF Char;
  Cuj$Packed141     = PACKED ARRAY [1..141] OF Char;
  Cuj$Packed142     = PACKED ARRAY [1..142] OF Char;
  Cuj$Packed143     = PACKED ARRAY [1..143] OF Char;
  Cuj$Packed144     = PACKED ARRAY [1..144] OF Char;
  Cuj$Packed145     = PACKED ARRAY [1..145] OF Char;
  Cuj$Packed146     = PACKED ARRAY [1..146] OF Char;
  Cuj$Packed147     = PACKED ARRAY [1..147] OF Char;
  Cuj$Packed148     = PACKED ARRAY [1..148] OF Char;
  Cuj$Packed149     = PACKED ARRAY [1..149] OF Char;
  Cuj$Packed150     = PACKED ARRAY [1..150] OF Char;
  Cuj$Packed151     = PACKED ARRAY [1..151] OF Char;
  Cuj$Packed152     = PACKED ARRAY [1..152] OF Char;
  Cuj$Packed153     = PACKED ARRAY [1..153] OF Char;
  Cuj$Packed154     = PACKED ARRAY [1..154] OF Char;
  Cuj$Packed155     = PACKED ARRAY [1..155] OF Char;
  Cuj$Packed156     = PACKED ARRAY [1..156] OF Char;
  Cuj$Packed157     = PACKED ARRAY [1..157] OF Char;
  Cuj$Packed158     = PACKED ARRAY [1..158] OF Char;
  Cuj$Packed159     = PACKED ARRAY [1..159] OF Char;
  Cuj$Packed160     = PACKED ARRAY [1..160] OF Char;
  Cuj$Packed161     = PACKED ARRAY [1..161] OF Char;
  Cuj$Packed162     = PACKED ARRAY [1..162] OF Char;
  Cuj$Packed163     = PACKED ARRAY [1..163] OF Char;
  Cuj$Packed164     = PACKED ARRAY [1..164] OF Char;
  Cuj$Packed165     = PACKED ARRAY [1..165] OF Char;
  Cuj$Packed166     = PACKED ARRAY [1..166] OF Char;
  Cuj$Packed167     = PACKED ARRAY [1..167] OF Char;
  Cuj$Packed168     = PACKED ARRAY [1..168] OF Char;
  Cuj$Packed169     = PACKED ARRAY [1..169] OF Char;
  Cuj$Packed170     = PACKED ARRAY [1..170] OF Char;
  Cuj$Packed171     = PACKED ARRAY [1..171] OF Char;
  Cuj$Packed172     = PACKED ARRAY [1..172] OF Char;
  Cuj$Packed173     = PACKED ARRAY [1..173] OF Char;
  Cuj$Packed174     = PACKED ARRAY [1..174] OF Char;
  Cuj$Packed175     = PACKED ARRAY [1..175] OF Char;
  Cuj$Packed176     = PACKED ARRAY [1..176] OF Char;
  Cuj$Packed177     = PACKED ARRAY [1..177] OF Char;
  Cuj$Packed178     = PACKED ARRAY [1..178] OF Char;
  Cuj$Packed179     = PACKED ARRAY [1..179] OF Char;
  Cuj$Packed180     = PACKED ARRAY [1..180] OF Char;
  Cuj$Packed181     = PACKED ARRAY [1..181] OF Char;
  Cuj$Packed182     = PACKED ARRAY [1..182] OF Char;
  Cuj$Packed183     = PACKED ARRAY [1..183] OF Char;
  Cuj$Packed184     = PACKED ARRAY [1..184] OF Char;
  Cuj$Packed185     = PACKED ARRAY [1..185] OF Char;
  Cuj$Packed186     = PACKED ARRAY [1..186] OF Char;
  Cuj$Packed187     = PACKED ARRAY [1..187] OF Char;
  Cuj$Packed188     = PACKED ARRAY [1..188] OF Char;
  Cuj$Packed189     = PACKED ARRAY [1..189] OF Char;
  Cuj$Packed190     = PACKED ARRAY [1..190] OF Char;
  Cuj$Packed191     = PACKED ARRAY [1..191] OF Char;
  Cuj$Packed192     = PACKED ARRAY [1..192] OF Char;
  Cuj$Packed193     = PACKED ARRAY [1..193] OF Char;
  Cuj$Packed194     = PACKED ARRAY [1..194] OF Char;
  Cuj$Packed195     = PACKED ARRAY [1..195] OF Char;
  Cuj$Packed196     = PACKED ARRAY [1..196] OF Char;
  Cuj$Packed197     = PACKED ARRAY [1..197] OF Char;
  Cuj$Packed198     = PACKED ARRAY [1..198] OF Char;
  Cuj$Packed199     = PACKED ARRAY [1..199] OF Char;
  Cuj$Packed200     = PACKED ARRAY [1..200] OF Char;
  Cuj$Packed201     = PACKED ARRAY [1..201] OF Char;
  Cuj$Packed202     = PACKED ARRAY [1..202] OF Char;
  Cuj$Packed203     = PACKED ARRAY [1..203] OF Char;
  Cuj$Packed204     = PACKED ARRAY [1..204] OF Char;
  Cuj$Packed205     = PACKED ARRAY [1..205] OF Char;
  Cuj$Packed206     = PACKED ARRAY [1..206] OF Char;
  Cuj$Packed207     = PACKED ARRAY [1..207] OF Char;
  Cuj$Packed208     = PACKED ARRAY [1..208] OF Char;
  Cuj$Packed209     = PACKED ARRAY [1..209] OF Char;
  Cuj$Packed210     = PACKED ARRAY [1..210] OF Char;
  Cuj$Packed211     = PACKED ARRAY [1..211] OF Char;
  Cuj$Packed212     = PACKED ARRAY [1..212] OF Char;
  Cuj$Packed213     = PACKED ARRAY [1..213] OF Char;
  Cuj$Packed214     = PACKED ARRAY [1..214] OF Char;
  Cuj$Packed215     = PACKED ARRAY [1..215] OF Char;
  Cuj$Packed216     = PACKED ARRAY [1..216] OF Char;
  Cuj$Packed217     = PACKED ARRAY [1..217] OF Char;
  Cuj$Packed218     = PACKED ARRAY [1..218] OF Char;
  Cuj$Packed219     = PACKED ARRAY [1..219] OF Char;
  Cuj$Packed220     = PACKED ARRAY [1..220] OF Char;
  Cuj$Packed221     = PACKED ARRAY [1..221] OF Char;
  Cuj$Packed222     = PACKED ARRAY [1..222] OF Char;
  Cuj$Packed223     = PACKED ARRAY [1..223] OF Char;
  Cuj$Packed224     = PACKED ARRAY [1..224] OF Char;
  Cuj$Packed225     = PACKED ARRAY [1..225] OF Char;
  Cuj$Packed226     = PACKED ARRAY [1..226] OF Char;
  Cuj$Packed227     = PACKED ARRAY [1..227] OF Char;
  Cuj$Packed228     = PACKED ARRAY [1..228] OF Char;
  Cuj$Packed229     = PACKED ARRAY [1..229] OF Char;
  Cuj$Packed230     = PACKED ARRAY [1..230] OF Char;
  Cuj$Packed231     = PACKED ARRAY [1..231] OF Char;
  Cuj$Packed232     = PACKED ARRAY [1..232] OF Char;
  Cuj$Packed233     = PACKED ARRAY [1..233] OF Char;
  Cuj$Packed234     = PACKED ARRAY [1..234] OF Char;
  Cuj$Packed235     = PACKED ARRAY [1..235] OF Char;
  Cuj$Packed236     = PACKED ARRAY [1..236] OF Char;
  Cuj$Packed237     = PACKED ARRAY [1..237] OF Char;
  Cuj$Packed238     = PACKED ARRAY [1..238] OF Char;
  Cuj$Packed239     = PACKED ARRAY [1..239] OF Char;
  Cuj$Packed240     = PACKED ARRAY [1..240] OF Char;
  Cuj$Packed241     = PACKED ARRAY [1..241] OF Char;
  Cuj$Packed242     = PACKED ARRAY [1..242] OF Char;
  Cuj$Packed243     = PACKED ARRAY [1..243] OF Char;
  Cuj$Packed244     = PACKED ARRAY [1..244] OF Char;
  Cuj$Packed245     = PACKED ARRAY [1..245] OF Char;
  Cuj$Packed246     = PACKED ARRAY [1..246] OF Char;
  Cuj$Packed247     = PACKED ARRAY [1..247] OF Char;
  Cuj$Packed248     = PACKED ARRAY [1..248] OF Char;
  Cuj$Packed249     = PACKED ARRAY [1..249] OF Char;
  Cuj$Packed250     = PACKED ARRAY [1..250] OF Char;
  Cuj$Packed251     = PACKED ARRAY [1..251] OF Char;
  Cuj$Packed252     = PACKED ARRAY [1..252] OF Char;
  Cuj$Packed253     = PACKED ARRAY [1..253] OF Char;
  Cuj$Packed254     = PACKED ARRAY [1..254] OF Char;
  Cuj$Packed255     = PACKED ARRAY [1..255] OF Char;
  Cuj$Packed256     = PACKED ARRAY [1..256] OF Char;
  Cuj$Bit           = [Bit(1),Unsafe] Boolean;
  Cuj$Byte          = [Byte] -128..127;
  Cuj$Ubyte         = [Byte] 0..255;
  Cuj$Word          = [Word] -32768..32767;
  Cuj$Uword         = [Word] 0..65535;
  Cuj$Quad          = [Quad,Unsafe]
                      RECORD
                        L0 : Unsigned;
                        L1 : Integer;
                      END;
  Cuj$Uquad         = [Quad,Unsafe]
                      RECORD
                        L0,
                        L1 : Unsigned;
                      END;
  Cuj$Octa          = [Octa,Unsafe]
                      RECORD
                        L0,
                        L1,
                        L2  : Unsigned;
                        L3  : Integer;
                      END;
  Cuj$Uocta         = [Octa,Unsafe]
                      RECORD
                        L0,
                        L1,
                        L2,
                        L3  : Unsigned;
                      END;
  Cuj$Character_Set = SET OF Char;
  Cuj$Prot_Type     = PACKED ARRAY [0..15] OF 0..1;
  Cuj$Message_Type  = RECORD
                        Username     : Cuj$Varying12;
                        Nodename     : Cuj$Varying10;
                        Mail_User,
                        Message      : Cuj$Varying255;
                        Message_Type : Integer;
                      END;
  Cuj$Quota_Type    = RECORD
                        Quota_Limit,
                        Quota_Used,
                        Quota_Remain,
                        Quota_Overdraft : Integer;
                      END;
  Cuj$File_Type     = RECORD
                        Filename     : Cuj$Varying255;
                        File_Id,
                        Directory_Id : Cuj$Varying20;
                        Eof_Vbn,
                        Hav,
                        Ffb,
                        Deq,
                        Gbc,
                        Fvl,
                        Rev          : Unsigned;
                        Cdt,
                        Rdt,
                        Edt,
                        Bdt          : Cuj$Varying23;
                        Prt          : Cuj$Varying21;
                        Uic          : Cuj$Varying9;
                        Rat          : Cuj$Varying43;
                        Rft          : Cuj$Varying10;
                        Org          : Cuj$Varying20;
                        Typ          : Cuj$Varying6;
                        Acl          : Cuj$Varying9;
                        Fhi          : ARRAY [1..4] OF Unsigned;
                      END;
  Cuj$Pointer_Type  = ^Cuj$Linklist_Type;
  Cuj$Linklist_Type = RECORD
                        String : Cuj$Packed255;
                        Lptr,
                        Rptr   : Cuj$Pointer_Type;
                      END;

{-----------------------------------------------------------------------------}

[Hidden]
VAR
  Stat        : [Volatile] Integer;
  Local_Node  : [Volatile] Cuj$Packed10;
  Translated  : [Volatile] Cuj$Bit := False;

{-----------------------------------------------------------------------------}

VAR
  Ast_In_Progress : [Volatile] Cuj$Bit;

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$CHANGE_TEXT                               *)
(*                                                                           *)
(*   This function will encrypt/decrypt a specified text string, depending   *)
(* on what flag is specified.  This has been provided by Shrinivas P. Arole  *)
(* (Vax God).                                                                *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Change_Text(VAR Text_String : [Volatile] VARYING [$L] OF Char;
                         Keyname : VARYING [$L2] OF Char := Cuj$C_Keyword;
                         Flag : Integer := Cuj$C_Encrypt) : Cuj$Bit;

  VAR
    X, Num,
    Gbl,
    Code_Cnt  : [Automatic] Integer;
    Last      : [Automatic] Cuj$Bit;

  BEGIN
    Code_Cnt := 1;
    Gbl := 0;
    Last := False;
    FOR X := 1 TO $L DO
      BEGIN
        Code_Cnt := Code_Cnt + 1;
        IF Code_Cnt > $L2 THEN
          Code_Cnt := 2;
        Num := Ord(Text_String.Body[X]);
        Gbl := Gbl + Ord(Keyname[Code_Cnt-1]) - 53;
        IF (Gbl > 65535) OR (Gbl < -65535) THEN
          Gbl := 0;
        IF Flag = Cuj$C_Encrypt THEN
          IF Last THEN
            Num := Num + Ord(Keyname[Code_Cnt]) - 133 - (Ord(Keyname[Code_Cnt-1]) DIV 8) - Gbl
           ELSE
            Num := Num - Ord(Keyname[Code_Cnt]) - 127 - (Ord(Keyname[Code_Cnt-1]) DIV 9) - Gbl
         ELSE
          IF Last THEN
            Num := Num - Ord(Keyname[Code_Cnt]) + 133 + (Ord(Keyname[Code_Cnt-1]) DIV 8) + Gbl
           ELSE
            Num := Num + Ord(Keyname[Code_Cnt]) + 127 + (Ord(Keyname[Code_Cnt-1]) DIV 9) + Gbl;
        Text_String.Body[X] := Chr(Num);
        Last := Succ(Last);
      END;
    Cuj$Change_Text := True;
  END; { Cuj$Change_Text }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$CHECK_ACCESS                              *)
(*                                                                           *)
(*   This function will determine if a specified user has access to a file,  *)
(* according to what protection flags are passed.  CUJ$CHECK_ACCESS will re- *)
(* turn FALSE if the specified user doesn't have access to the file.         *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Check_Access(Filename : VARYING [$L] OF Char;
                          Username : Cuj$Varying12 := Chr(0);
                          Prot_Flags : Cuj$Varying5) : Cuj$Bit;

  VAR
    User  : [Automatic] Cuj$Packed12;
    X     : [Automatic] Integer;
    Privs : [Automatic] Arm$Type;
    List  : [Automatic]
            RECORD
              Buflen,
              Itmcod  : Cuj$Uword;
              Bufadr,
              Lenadr,
              Termin  : Unsigned;
            END;

  BEGIN
    IF Username = Chr(0) THEN
      BEGIN
        Lib$Getjpi(Jpi$_Username,,,,User);
        Username := User;
      END;
    FOR X := 1 TO Prot_Flags.Length DO
      IF Prot_Flags.Body[X] IN ['d'..'w'] THEN
        Prot_Flags.Body[X] := Chr(Ord(Prot_Flags.Body[X])-32);
    List.Buflen := Size(Privs);
    List.Itmcod := Chp$_Access;
    List.Bufadr := Iaddress(Privs);
    List.Lenadr := 0;
    List.Termin := 0;
    Privs.Arm$V_Read := (Index(Prot_Flags, 'R') > 0) OR (Index(Prot_Flags, 'W') > 0) OR (Index(Prot_Flags, 'E') > 0) OR (Index(Prot_Flags, 'D') > 0);
    Privs.Arm$V_Write := Index(Prot_Flags, 'W') > 0;
    Privs.Arm$V_Execute := (Index(Prot_Flags, 'E') > 0) AND NOT(Privs.Arm$V_Read);
    Privs.Arm$V_Delete := Index(Prot_Flags, 'D') > 0;
    Privs.Arm$V_Control := Index(Prot_Flags, 'C') > 0;
    Stat := $Check_Access(Objtyp := Acl$C_File, Objnam := Filename, Usrnam := Username, Itmlst := List);
    Cuj$Check_Access := Odd(Stat);
  END; { Cuj$Check_Access }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                          CUJ$CREATE_DCL_PROCESS                           *)
(*                                                                           *)
(*   This function will create a subprocess, which will allow a user to pass *)
(* DCL commands/parameters to it.  CUJ$CREATE_DCL_PROCESS will return FALSE  *)
(* if the subprocess could not be created.                                   *)
(*                                                                           *)
(*                                                                           *)
(*                               ** WARNING **                               *)
(*                                                                           *)
(*   CUJ$CREATE_DCL_PROCESS should be called before any other routine that   *)
(* creates channels, i.e. SMG$CREATE_PASTEBOARD.                             *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Create_Dcl_Process(VAR Dcl_Channel : [Volatile] Cuj$Uword;
                                VAR Pid_Address : [Volatile] Unsigned;
                                Output_File : PACKED ARRAY [$A..$B:Integer] OF Char := Chr(0);
                                Error_File : PACKED ARRAY [$C..$D:Integer] OF Char := Chr(0);
                                Process_Name : PACKED ARRAY [$E..$F:Integer] OF Char := Chr(0);
                                Base_Priority : Integer := -1) : Cuj$Bit;

  CONST
    Loginout = 'SYS$SYSTEM:LOGINOUT.EXE';
    Mbx$Dcl  = 'MBX$DCL_COMMAND';
    Mbx$Mask = %b'1111111100000000';

  VAR
    List : [Automatic]
           RECORD
             Buflen,
             Itmcod  : Cuj$Uword;
             Bufadr,
             Lenadr,
             Termin  : Integer;
           END;
    Base : [Automatic] Integer;
    Out,
    Err  : [Automatic] Cuj$Varying255;
    Pid  : [Automatic] Cuj$Packed8;
    Prc  : [Automatic] Cuj$Packed15;

  BEGIN
    Stat := $Crembx(Chan := Dcl_Channel, Promsk := Mbx$Mask, Lognam := Mbx$Dcl);
    IF NOT(Odd(Stat)) THEN
      Cuj$Create_Dcl_Process := False
     ELSE
      BEGIN
        Out := '';
        List.Buflen := Lnm$C_Namlength;
        List.Itmcod := Lnm$_String;
        List.Bufadr := Iaddress(Out.Body);
        List.Lenadr := Iaddress(Out.Length);
        List.Termin := 0;
        Stat := $Trnlnm(Attr := Lnm$M_Case_Blind, Tabnam := Cuj$T_Process, Lognam := 'TT', Itmlst := List);
        IF NOT(Odd(Stat)) THEN
          Cuj$Create_Dcl_Process := False
         ELSE
          BEGIN
            Err := Out;
            IF Output_File <> Chr(0) THEN
              Out := Substr(Output_File, 1, $B);
            IF Error_File <> Chr(0) THEN
              Err := Substr(Error_File, 1, $D);
            IF Process_Name <> Chr(0) THEN
              Prc := Substr(Process_Name, 1, $F)
             ELSE
              BEGIN
                Lib$Getjpi(Jpi$_Master_Pid,,,,Pid);
                Prc := 'DCL_' + Pid;
              END;
            IF Base_Priority > -1 THEN
              Base := Base_Priority
             ELSE
              Lib$Getjpi(Jpi$_Prib,,,%REF Base);
            Stat := $Creprc(Pidadr := Pid_Address, Image := Loginout, Input := Mbx$Dcl, Output := Out.Body, Error := Err.Body, Prcnam := Prc, Baspri := Base, Stsflg := Prc$M_Inter);
            Cuj$Create_Dcl_Process := Odd(Stat);
          END;
      END;
  END; { Cuj$Create_Dcl_Process }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                CUJ$DO_DCL                                 *)
(*                                                                           *)
(*   This function will pass DCL commands/parameters to the DCL subprocess   *)
(* created by CUJ$CREATE_DCL_PROCESS.  CUJ$DO_DCL will return FALSE if the   *)
(* command/parameter could not be passed into the subprocess.                *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Do_Dcl(Dcl_Channel : [Volatile] Cuj$Uword;
                    Dcl_String : VARYING [$L] OF Char;
                    Flag : Integer := Cuj$C_Normal) : Cuj$Bit;

  BEGIN
    IF Flag = Cuj$C_Wait THEN
      Stat := $Qiow(Chan := Dcl_Channel, Func := Io$_Writevblk, P1 := Dcl_String.Body, P2 := Dcl_String.Length)
     ELSE
      Stat := $Qio(Chan := Dcl_Channel, Func := Io$_Writevblk+Io$M_Norswait, P1 := Dcl_String.Body, P2 := Dcl_String.Length);
    Cuj$Do_Dcl := Odd(Stat);
  END; { Cuj$Do_Dcl }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                 CUJ$EDIT                                  *)
(*                                                                           *)
(*   This function will edit a specified text string according to the edit-  *)
(* ing flag(s) passed to it.  CUJ$EDIT will return the resultant string.     *)
(* This is similar to the DCL lexical function F$EDIT.                       *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Edit(Text_String : VARYING [$L] OF Char;
                  Flags : Integer) : Cuj$Varying2000;

  VAR
    Over,
    Idx,
    X, Cnt : [Static] Integer;
    Temp   : [Static] Cuj$Varying2000;
    Blank  : [Static] Cuj$Bit;

  BEGIN
    Blank := True;
    Idx := 1;
    IF Text_String.Length > 0 THEN
      REPEAT
        IF (Text_String.Body[Idx] <> ' ') AND (Text_String.Body[Idx] <> Chr(0)) THEN
          Blank := False
         ELSE
          Idx := Idx + 1;
      UNTIL NOT(Blank) OR (Idx > Text_String.Length);
    IF Blank THEN
      Cuj$Edit := ''
     ELSE
      BEGIN
        Cnt := 1;
        FOR Idx := 0 TO 8 DO
          BEGIN
            IF (Flags MOD 2) = 1 THEN
              CASE Cnt OF
                 Cuj$C_Collapse     : BEGIN
                                        Temp := '';
                                        FOR X := 1 TO Text_String.Length DO
                                          IF NOT(Ord(Text_String.Body[X]) IN [9, 32]) THEN
                                            Temp := Temp + Text_String.Body[X];
                                        Text_String := Temp;
                                      END;
                 Cuj$C_Compress     : BEGIN
                                        Temp := '';
                                        FOR X := 1 TO Text_String.Length DO
                                          IF Ord(Text_String.Body[X]) = Cuj$Tab THEN
                                            Text_String.Body[X] := Chr(Cuj$Space);
                                        FOR X := 1 TO Text_String.Length-1 DO
                                          IF NOT((Text_String.Body[X] = Text_String.Body[X+1]) AND
                                             (Ord(Text_String.Body[X]) = Cuj$Space)) THEN
                                            Temp := Temp + Text_String.Body[X];
                                        IF NOT(Ord(Text_String.Body[Text_String.Length]) IN [Cuj$Tab,Cuj$Space]) THEN
                                          Temp := Temp + Text_String.Body[Text_String.Length];
                                        Text_String := Temp;
                                      END;
                Cuj$C_Lowercase     : FOR X := 1 TO Text_String.Length DO
                                        IF Text_String.Body[X] IN ['A'..'Z'] THEN
                                          Text_String.Body[X] := Chr(Ord(Text_String.Body[X])+32);
                Cuj$C_Trim          : BEGIN
                                        X := 1;
                                        Over := Text_String.Length;
                                        WHILE Text_String.Body[X] IN [Chr(Cuj$Space), Chr(Cuj$Tab)] DO
                                          X := X + 1;
                                        WHILE Text_String.Body[Over] IN [Chr(Cuj$Space), Chr(Cuj$Tab)] DO
                                          Over := Over - 1;
                                        Text_String := Substr(Text_String, X, Over-X+1);
                                      END;
                Cuj$C_Uncomment     : BEGIN
                                        Over := Index(Text_String, '!');
                                        IF Over > 1 THEN
                                          Text_String := Substr(Text_String, 1, Over-1)
                                         ELSE
                                          IF Over = 1 THEN
                                            Text_String := '';
                                      END;
                Cuj$C_Upcase        : FOR X := 1 TO Text_String.Length DO
                                        IF Text_String.Body[X] IN ['a'..'z'] THEN
                                          Text_String.Body[X] := Chr(Ord(Text_String.Body[X])-32);
                Cuj$C_Ascii         : BEGIN
                                        Temp := '';
                                        FOR X := 1 TO Text_String.Length DO
                                          IF Ord(Text_String.Body[X]) IN [27, 32..126, 161..171, 176..179, 181..183, 185..189, 191..207, 209..221, 223..239, 241..253] THEN
                                            Temp := Temp + Text_String.Body[X];
                                        Text_String := Substr(Temp, 1, Temp.Length);
                                      END;
                Cuj$C_Trim_Leading  : BEGIN
                                        X := 1;
                                        WHILE Text_String.Body[X] IN [Chr(Cuj$Space), Chr(Cuj$Tab)] DO
                                          X := X + 1;
                                        Text_String := Substr(Text_String, X, Text_String.Length-X+1);
                                      END;
                Cuj$C_Trim_Trailing : BEGIN
                                        Over := Text_String.Length;
                                        WHILE (Text_String.Body[Over] IN [Chr(Cuj$Space), Chr(Cuj$Tab)]) AND (Over > 1) DO
                                          Over := Over - 1;
                                        Text_String := Substr(Text_String, 1, Over);
                                      END;
              END;
            Flags := Flags DIV 2;
            Cnt := Cnt * 2;
          END;
        Cuj$Edit := Text_String;
      END;
  END; { Cuj$Edit }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$EDIT_DISPLAY                              *)
(*                                                                           *)
(*   This function will edit a specified display.  CUJ$EDIT_DISPLAY will re- *)
(* turn FALSE if the cursor row or column is out of the display's range.     *)
(* Note that the display should already be pasted onto the pasteboard.       *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Edit_Display(Display_Id, Keyboard_Id : [Volatile] Unsigned;
                          Start_Row, Start_Column : Integer := 1;
                          VAR Resultant_Linklist : [Volatile] Cuj$Pointer_Type;
                          Terminators : PACKED ARRAY [$A..$B:Integer] OF Char := Chr(Cuj$Return)+Chr(Cuj$Ctrl_Z);
                          VAR Return_Value : [Volatile] Cuj$Uword;
                          Limiting_Set : Cuj$Character_Set := [Chr(32)..Chr(126)];
                          Placement_Mode : Integer := Cuj$C_Insert) : Cuj$Bit;

  VAR
    Y, X, Width,
    Height        : [Automatic] Integer := 1;
    Head, Tail,
    Current       : [Automatic] Cuj$Pointer_Type;
    Key           : [Automatic] Cuj$Uword;
    Str           : [Automatic] Cuj$Packed255;


  PROCEDURE Add_To_List(String : Cuj$Packed255);

    VAR
      Temp : Cuj$Pointer_Type;

    BEGIN
      New(Temp);
      Temp^.String := String;
      Temp^.Rptr := Nil;
      Temp^.Lptr := Current;
      Current^.Rptr := Temp;
      Current := Current^.Rptr;
    END; { Add_To_List }


  PROCEDURE Add_Char(List : Cuj$Pointer_Type);

    VAR
      A, B  : Integer;
      Last,
      Last2 : Char;

    BEGIN
      IF Y <= Height THEN
        BEGIN
          FOR A := 1 TO Y DO
            List := List^.Rptr;
          Last := List^.String[Width];
          IF Placement_Mode = Cuj$C_Insert THEN
            FOR A := Width DOWNTO X+1 DO
              List^.String[A] := List^.String[A-1];
          List^.String[X] := Chr(Key);
          IF Placement_Mode = Cuj$C_Insert THEN
            FOR A := Y+1 TO Height DO
              BEGIN
                List := List^.Rptr;
                Last2 := Last;
                Last := List^.String[Width];
                FOR B := Width DOWNTO 2 DO
                  List^.String[B] := List^.String[B-1];
                List^.String[1] := Last2;
              END;
          X := X + 1;
          IF X > Width THEN
            BEGIN
              X := 1;
              Y := Y + 1;
            END;
        END;
    END; { Add_Char }


  PROCEDURE Delete_Char(List : Cuj$Pointer_Type);

    VAR
      A, B  : Integer;
      Last,
      Last2 : Char;

    BEGIN
      X := X - 1;
      IF X = 0 THEN
        BEGIN
          X := Width;
          Y := Y - 1;
        END;
      IF Y > 0 THEN
        BEGIN
          Last2 := ' ';
          FOR A := Height DOWNTO Y+1 DO
            BEGIN
              Last := List^.String[1];
              FOR B := 1 TO Width-1 DO
                List^.String[B] := List^.String[B+1];
              IF List^.Rptr <> Nil THEN
                List^.String[Width] := Last2
               ELSE
                List^.String[Width] := ' ';
              Last2 := Last;
              List := List^.Lptr;
            END;
          FOR A := X TO Width-1 DO
            List^.String[A] := List^.String[A+1];
          List^.String[Width] := Last2;
        END
       ELSE
        BEGIN
          X := 1;
          Y := 1;
        END;
    END; { Delete_Char }


  PROCEDURE Display_List(List : Cuj$Pointer_Type);

    VAR
      A : Integer;

    BEGIN
      FOR A := 1 TO Height DO
        BEGIN
          List := List^.Rptr;
          Smg$Put_Chars(Display_Id, List^.String, A, 1);
        END;
    END; { Display_List }


  PROCEDURE End_Of_Line(List : Cuj$Pointer_Type);

    VAR
      Ok  : Cuj$Bit := False;
      Tmp : Cuj$Varying2000;

    BEGIN
      Y := Height + 1;
      REPEAT
        Tmp := Cuj$Edit(List^.String, Cuj$C_Trim_Trailing);
        IF Tmp.Length > 0 THEN
          BEGIN
            X := Tmp.Length + 1;
            Y := Y - 1;
            IF X > Width THEN
              IF Y < Height THEN
                BEGIN
                  Y := Y + 1;
                  X := 1;
                END;
            Ok := True;
          END
         ELSE
          IF List^.Lptr <> Nil THEN
            BEGIN
              X := 1;
              List := List^.Lptr;
              Y := Y - 1;
            END;
      UNTIL Ok OR (List^.Lptr = Nil);
    END; { End_Of_Line }


  PROCEDURE Ctrl_X_Delete(List : Cuj$Pointer_Type);

    BEGIN
      REPEAT
        Delete_Char(List);
      UNTIL (X = 1) AND (Y = 1);
    END; { Ctrl_X_Delete }


  BEGIN
    Cuj$Edit_Display := True;
    Smg$Get_Display_Attr(Display_Id, Height, Width);
    IF NOT(Odd(Smg$Set_Cursor_Abs(Display_Id, Start_Row, Start_Column))) THEN
      Cuj$Edit_Display := False
     ELSE
      BEGIN
        New(Head);
        Head^.String := '';
        Head^.Lptr := Nil;
        Head^.Rptr := Nil;
        Current := Head;
        FOR Y := 1 TO Height DO
          BEGIN
            Smg$Read_From_Display(Display_Id, Str,,Y);
            Add_To_List(Str);
          END;
        Tail := Current;
        Smg$Set_Cursor_Abs(Display_Id, Start_Row, Start_Column);
        Y := Start_Row;
        REPEAT
          Smg$Read_Keystroke(Keyboard_Id, Key);
          CASE Key OF
            Cuj$Up_Arrow    : IF Y = 1 THEN
                                Y := Height
                               ELSE
                                Y := Y - 1;
            Cuj$Down_Arrow  : IF Y = Height THEN
                                Y := 1
                               ELSE
                                Y := Y + 1;
            Cuj$Left_Arrow  : BEGIN
                                X := X - 1;
                                IF X = 0 THEN
                                  BEGIN
                                    X := Width;
                                    Y := Y - 1;
                                  END;
                                IF Y <= 0 THEN
                                  BEGIN
                                    X := 1;
                                    Y := 1;
                                  END;
                              END;
            Cuj$Right_Arrow : IF Y <= Height THEN
                                BEGIN
                                  X := X + 1;
                                  IF X > Width THEN 
                                    BEGIN
                                      X := 1;
                                      Y := Y + 1;
                                    END;
                                END;
            Cuj$Delete      : Delete_Char(Tail);
            Cuj$Ctrl_A      : CASE Placement_Mode OF
                                Cuj$C_Insert     : Placement_Mode := Cuj$C_Overstrike;
                                Cuj$C_Overstrike : Placement_Mode := Cuj$C_Insert;
                              END;
            Cuj$Ctrl_E      : End_Of_Line(Tail);
            Cuj$Ctrl_H      : BEGIN
                                X := 1;
                                Y := 1;
                              END;
            Cuj$Ctrl_U      : Ctrl_X_Delete(Tail); (* It's also Ctrl_X when    *)
                                                   (* using SMG$READ_KEYSTROKE *)
          OTHERWISE
            IF (Chr(Key) IN Limiting_Set) AND (Index(Terminators, Chr(Key)) = 0) THEN
              Add_Char(Head);
          END;
          Smg$Begin_Display_Update(Display_Id);
          Smg$Erase_Display(Display_Id);
          Display_List(Head);
          Smg$Set_Cursor_Abs(Display_Id, Y, X);
          Smg$End_Display_Update(Display_Id);
        UNTIL Index(Terminators, Chr(Key)) > 0;
        Return_Value := Key;
        Resultant_Linklist := Nil;
        IF Chr(Key) = Terminators[1] THEN
          Resultant_Linklist := Head;
      END;
  END; { Cuj$Edit_Display }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                               CUJ$EDIT_FILE                               *)
(*                                                                           *)
(*   This function will edit a specified file with the EDT or TPU editor,    *)
(* depending on what flag is passed into the function.                       *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Edit_File(Filename : VARYING [$L] OF Char;
                       Flag : Integer := Cuj$C_Edt) : Cuj$Bit;

  [External(Edt$Edit)]
  FUNCTION Edit_With_Edt(%DESCR Fnm : VARYING [$L2] OF Char) : Integer; External;


  [External(Tpu$Tpu)]
  FUNCTION Edit_With_Tpu(%DESCR Cmd : VARYING [$L3] OF Char) : Integer; External;


  BEGIN
    CASE Flag OF
      Cuj$C_Edt : Stat := Edit_With_Edt(Filename);
      Cuj$C_Tpu : Stat := Edit_With_Tpu('TPU '+Filename);
    END;
    Cuj$Edit_File := Odd(Stat);
  END; { Cuj$Edit_File }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                               CUJ$ELEMENT                                 *)
(*                                                                           *)
(*   This function will extract an element from a specified string in which  *)
(* the elements are separated by the specified delimiter.  If the delimiter  *)
(* is not found in the string, CUJ$ELEMENT will return the string.  Other-   *)
(* wise, it will return the element.  This function is similar to the DCL    *)
(* lexical function F$ELEMENT.                                               *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Element(Text_String : VARYING [$L] OF Char;
                     Delimiter : Char;
                     Element_Number : Cuj$Uword := 0) : Cuj$Varying2000;

  VAR
    Idx, X  : [Automatic] Integer;
    Done    : [Automatic] Cuj$Bit;
    Tmp     : [Automatic] Cuj$Varying2000;

  BEGIN
    Done := False;
    Idx := Index(Text_String, Delimiter);
    IF Idx = 0 THEN
      Cuj$Element := Text_String
     ELSE
      IF Element_Number = 0 THEN
        Cuj$Element := Substr(Text_String, 1, Idx-1)
       ELSE
        BEGIN
          X := 0;
          Idx := 1;
          Tmp := '';
          REPEAT
            IF Text_String.Body[Idx] = Delimiter THEN
              X := X + 1;
            Idx := Idx + 1;
          UNTIL (X = Element_Number) OR (Idx > $L);
          IF Idx > $L THEN
            Cuj$Element := ''
           ELSE
            BEGIN
              REPEAT
                IF Text_String.Body[Idx] = Delimiter THEN
                  Done := True
                 ELSE
                  BEGIN
                    Tmp := Tmp + Text_String.Body[Idx];
                    Idx := Idx + 1;
                  END;
              UNTIL Done OR (Idx > $L);
              Cuj$Element := Tmp;
            END;
        END;
  END; { Cuj$Element }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                            CUJ$GET_FILE_INFO                              *)
(*                                                                           *)
(*   This function will return information about a specified file, such as   *)
(* its file attributes and record attributes.  The file may contain wild-    *)
(* cards.  This routine was written with assistance from Shrinivas P. Arole. *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_File_Info(Filename : VARYING [$L] OF Char;
                           VAR File_Record_Info : [Volatile] ARRAY [$A..$B:Integer] OF Cuj$File_Type;
                           VAR Number_Of_Files : [Volatile] Integer) : Cuj$Bit;

  TYPE
    $Bool         = Cuj$Bit;
    $Bit4         = [Bit(4),Unsafe] 0..15;
    File_Atr_Type = ARRAY [1..11] OF Atr$Type;
    Rat$Type      = RECORD
                      CASE Integer OF
                        1 : (Rat$R_Recattr : [Byte(32)] RECORD END);
                        2 : (Rat$B_Rfo,                              (* Record format and file attributes      *)
                             Rat$B_Atr  : Cuj$Ubyte;                 (* Record attributes                      *)
                             Rat$W_Lrl  : Cuj$Uword;                 (* Longest record length                  *)
                             Rat$L_Hbk,                              (* Highest vbn allocated                  *)
                             Rat$L_Ebk  : Unsigned;                  (* Eof vbn                                *)
                             Rat$W_Ffb  : Cuj$Uword;                 (* First free byte in eof vbn             *)
                             Rat$B_Bkz,                              (* FHC bucket size                        *)
                             Rat$B_Hsz  : Cuj$Ubyte;                 (* VFC header size                        *)
                             Rat$W_Mrz,                              (* Maximum record size                    *)
                             Rat$W_Dxq,                              (* Default extend quantity                *)
                             Rat$W_Gbc  : Cuj$Uword;                 (* Global buffer count                    *)
                             Rat$$Fill  : ARRAY [1..8] OF Cuj$Byte;
                             Rat$W_Ver  : Cuj$Uword);                (* File version limit                     *)
                        3 : (Rat$V_Rfm  : [Pos(0)] $Bit4;            (* Record format                          *)
                             Rat$V_Org  : [Pos(4)] $Bit4);           (* File organization                      *)
                        4 : (Rat$V_Ftn  : [Pos(8)] $Bool;            (* Fortran cc                             *)
                             Rat$V_Cr   : [Pos(9)] $Bool;            (* Implied cc (lf-record-cr)              *)
                             Rat$V_Prn  : [Pos(10)] $Bool;           (* Print cc                               *)
                             Rat$V_Blk  : [Pos(11)] $Bool);          (* Records don't cross block boundaries   *)
                        5 : (Rat$W_Hbk0 : [Pos(32)] Cuj$Uword;       (* Words that make up the longword HBK    *)
                             Rat$W_Hbk2 : [Pos(48)] Cuj$Uword;       (* and EBK fields.  They must be switched *)
                             Rat$W_Ebk0 : [Pos(64)] Cuj$Uword;       (* in order to get the correct number.    *)
                             Rat$W_Ebk2 : [Pos(80)] Cuj$Uword);
                    END;
    Prot$Type     = RECORD
                      CASE Integer OF
                        1 : (Prot$W_Prot : Cuj$Uword);       (* Protection mask *)
                        2 : (Prot$V_Sys  : [Pos(0)] $Bit4;   (* System          *)
                             Prot$V_Own  : [Pos(4)] $Bit4;   (* Owner           *)
                             Prot$V_Grp  : [Pos(8)] $Bit4;   (* Group           *)
                             Prot$V_Wld  : [Pos(12)] $Bit4); (* World           *)
                    END;
    Uicc$Type     = RECORD
                      CASE Integer OF
                        1 : (Uicc$L_Uic  : Unsigned);  (* UIC code          *)
                        2 : (Uicc$W_Mbm,               (* Octal member code *)
                             Uicc$W_Grp  : Cuj$Uword); (* Octal group code  *)
                    END;
    Fhd$Type      = RECORD
                      CASE Integer OF
                        1 : (Fhd$R_Header : [Byte(512)] RECORD END);
                        2 : (Fhd$B_Id,                               (* ID area offset       *)
                             Fhd$B_Map,                              (* Map area offset      *)
                             Fhd$B_Acl,                              (* ACL area offset      *)
                             Fhd$B_Res    : Cuj$Ubyte);              (* Reserved area offset *)
                    END;
    Acet$Type     = RECORD
                      CASE Integer OF
                        1 : (Acet$R_Ace  : [Byte(6)] RECORD END);
                        2 : (Acet$L_Uic  : Unsigned;
                             Acet$B_Opt,
                             Acet$B_Acc  : Cuj$Ubyte);
                        3 : (Acet$W_Mbm  : [Pos(0)] Cuj$Uword;
                             Acet$W_Grp  : [Pos(16)] Cuj$Uword);
                    END;
    Fch$Type      = RECORD
                      CASE Integer OF
                        1 : (Fch$R_Overlay   : Unsigned);
                        2 : (Fch$V_Wascontig : [Pos(0)] $Bool;   (* ???                               *)
                             Fch$V_Nobackup  : [Pos(1)] $Bool;   (* Do not backup file                *)
                             Fch$V_Writeback : [Pos(2)] $Bool;   (* Writeback                         *)
                             Fch$V_Readcheck : [Pos(3)] $Bool;   (* Read checking                     *)
                             Fch$V_Writcheck : [Pos(4)] $Bool;   (* Write checking                    *)
                             Fch$V_Contigb   : [Pos(5)] $Bool;   (* Contiguous allocation -- best try *)
                             Fch$V_Locked    : [Pos(6)] $Bool;   (* Locked                            *)
                             Fch$V_Contig    : [Pos(7)] $Bool;   (* Contiguous allocation             *)
                             Fch$V_Reserved1 : [Pos(8)] $Bool;
                             Fch$V_Reserved2 : [Pos(9)] $Bool;
                             Fch$V_Reserved3 : [Pos(10)] $Bool;
                             Fch$V_Badacl    : [Pos(11)] $Bool;  (* Bad ACL                           *)
                             Fch$V_Spool     : [Pos(12)] $Bool;  (* Spool                             *)
                             Fch$V_Directory : [Pos(13)] $Bool;  (* Directory                         *)
                             Fch$V_Badblock  : [Pos(14)] $Bool;  (* Bad block                         *)
                             Fch$V_Markdel   : [Pos(15)] $Bool;  (* Marked for delete                 *)
                             Fch$V_Nocharge  : [Pos(16)] $Bool;  (* ???                               *)
                             Fch$V_Erase     : [Pos(17)] $Bool); (* Erase on delete                   *)
                    END;

  VAR
    Temp        : [Automatic] Cuj$Uword VALUE 0;
    X, Code, Ix : [Automatic] Integer;
    Tdate       : [Automatic] Cuj$Varying255;
    Cdate,
    Rdate,
    Edate,
    Bdate       : [Static] Cuj$Uquad;
    Tfnameptr   : [Static,Unsafe] ^Cuj$Packed255;
    Tfname,
    Device,
    Exp_Str,
    Res_Exp_Str : [Static] VARYING [Nam$C_Maxrss] OF Char VALUE Chr(0);
    File_Header : [Static] Fhd$Type;
    File_Rat    : [Static] Rat$Type;
    Name_Fab    : [Static] Fab$Type;
    File_Nam    : [Static] Nam$Type;
    File_Atr    : [Static] File_Atr_Type;
    File_Fib    : [Static] Fib$Type;
    Ace         : [Static] Ace$Type;
    Prots       : [Static] Prot$Type;
    Uicc        : [Static] Uicc$Type;
    Revisions,
    Devchan     : [Static] Cuj$Uword;
    Prot_Str    : [Static] ARRAY [0..15] OF Cuj$Varying4;
    Recrfm_Str  : [Static] ARRAY [0..6] OF Cuj$Varying10;
    Filorg_Str  : [Static] ARRAY [0..3] OF Cuj$Varying10;

  VALUE
    Prot_Str := ('RWED', 'WED', 'RED', 'ED', 'RWD', 'WD', 'RD', 'D', 'RWE', 'WE', 'RE', 'E', 'RW', 'W', 'R', '');
    Recrfm_Str := ('UNDEFINED', 'FIXED', 'VARIABLE', 'VFC', 'STREAM', 'LFSTREAM', 'CRSTREAM');
    Filorg_Str := ('SEQUENTIAL', 'RELATIVE', 'INDEXED', 'DIRECT');
    

  FUNCTION Expand_Filename(Fnm : Cuj$Varying255) : Integer;

    BEGIN
      Code := Rms$_Normal;
      IF Fnm <> Chr(0) THEN
        BEGIN
          File_Nam.Nam$B_Bid := Nam$C_Bid;
          File_Nam.Nam$B_Bln := Nam$C_Bln;
          File_Nam.Nam$B_Ess := Nam$C_Maxrss;
          File_Nam.Nam$B_Esl := Nam$C_Maxrss;
          File_Nam.Nam$L_Esa := Iaddress(Exp_Str.Body);
          File_Nam.Nam$B_Nop := 0;
          File_Nam.Nam$B_Rss := Nam$C_Maxrss;
          File_Nam.Nam$B_Rsl := Nam$C_Maxrss;
          File_Nam.Nam$L_Rsa := Iaddress(Res_Exp_Str.Body);

          Name_Fab.Fab$B_Bid := Fab$C_Bid;
          Name_Fab.Fab$B_Bln := Fab$C_Bln;
          Name_Fab.Fab$L_Fna := Iaddress(Fnm.Body);
          Name_Fab.Fab$B_Fns := Fnm.Length;
          Name_Fab.Fab$L_Fop := Fab$M_Ofp;
          Name_Fab.Fab$L_Nam := Iaddress(File_Nam);

          Code := $Parse(Name_Fab);
        END;
      IF Odd(Code) THEN
        Code := $Search(Name_Fab);
      Exp_Str.Length := File_Nam.Nam$B_Esl;
      Res_Exp_Str.Length := File_Nam.Nam$B_Rsl;
      Expand_Filename := Code;
    END; { Expand_Filename }


  FUNCTION Open_File : Integer;

    VAR
      Fname_Desc, File_Fib_Desc : Dsc1$Type;

    BEGIN
      FOR X := 2 TO 16 DO
        Device.Body[X-1] := File_Nam.Nam$T_Dvi[X];
      Device.Length := Ord(File_Nam.Nam$T_Dvi[1]);
      Code := $Assign(Device, Devchan);
      File_Fib.Fib$W_Fid := File_Nam.Nam$W_Fid;
      File_Fib.Fib$W_Did := File_Nam.Nam$W_Did;
      File_Fib_Desc := Dsc1$Type[Dsc$W_Maxstrlen : Size(File_Fib);
                                 Dsc$B_Dtype : Dsc$K_Dtype_Z;
                                 Dsc$B_Class : Dsc$K_Class_S;
                                 Dsc$A_Pointer : Iaddress(File_Fib)];
      Tfnameptr := File_Nam.Nam$L_Name;
      Tfname.Length := File_Nam.Nam$B_Name + File_Nam.Nam$B_Type + File_Nam.Nam$B_Ver;
      FOR X := 1 TO Tfname.Length DO
        Tfname.Body[X] := Tfnameptr^[X];

      File_Atr[1].Atr$W_Size := Size(Prots);
      File_Atr[1].Atr$W_Type := Atr$C_Fpro;             (* File protection flags *)
      File_Atr[1].Atr$L_Addr := Iaddress(Prots);

      File_Atr[2].Atr$W_Size := Size(File_Rat);
      File_Atr[2].Atr$W_Type := Atr$C_Recattr;          (* Record attributes     *)
      File_Atr[2].Atr$L_Addr := Iaddress(File_Rat);

      File_Atr[3].Atr$W_Size := Size(Cdate);
      File_Atr[3].Atr$W_Type := Atr$C_Credate;          (* Creation date         *)
      File_Atr[3].Atr$L_Addr := Iaddress(Cdate);

      File_Atr[4].Atr$W_Size := Size(Rdate);
      File_Atr[4].Atr$W_Type := Atr$C_Revdate;          (* Revision date         *)
      File_Atr[4].Atr$L_Addr := Iaddress(Rdate);

      File_Atr[5].Atr$W_Size := Size(Edate);
      File_Atr[5].Atr$W_Type := Atr$C_Expdate;          (* Expiration date       *)
      File_Atr[5].Atr$L_Addr := Iaddress(Edate);

      File_Atr[6].Atr$W_Size := Size(Bdate);
      File_Atr[6].Atr$W_Type := Atr$C_Bakdate;          (* Backup date           *)
      File_Atr[6].Atr$L_Addr := Iaddress(Bdate);

      File_Atr[7].Atr$W_Size := Size(Uicc);
      File_Atr[7].Atr$W_Type := Atr$C_Uic;              (* File owner UIC        *)
      File_Atr[7].Atr$L_Addr := Iaddress(Uicc);

      File_Atr[8].Atr$W_Size := Size(Revisions);
      File_Atr[8].Atr$W_Type := Atr$C_Ascdates;         (* Number of revisions   *)
      File_Atr[8].Atr$L_Addr := Iaddress(Revisions);

      File_Atr[9].Atr$W_Size := Size(Ace);
      File_Atr[9].Atr$W_Type := Atr$C_Readace;          (* Access control entry  *)
      File_Atr[9].Atr$L_Addr := Iaddress(Ace);

      File_Atr[10].Atr$W_Size := Size(File_Header);
      File_Atr[10].Atr$W_Type := Atr$C_Header;          (* 512 byte header       *)
      File_Atr[10].Atr$L_Addr := Iaddress(File_Header);

      File_Atr[11].Atr$W_Size := 0;
      File_Atr[11].Atr$W_Type := 0;                     (* End of list           *)
      File_Atr[11].Atr$L_Addr := 0;

      Fname_Desc := Dsc1$Type[Dsc$W_Maxstrlen : Tfname.Length;
                              Dsc$B_Dtype : Dsc$K_Dtype_T;
                              Dsc$B_Class : Dsc$K_Class_S;
                              Dsc$A_Pointer : Iaddress(Tfname.Body)];
      IF Odd(Code) THEN
        Code := $Qiow(%IMMED 0, %IMMED Devchan, %IMMED Io$_Access,,,,File_Fib_Desc, %IMMED Iaddress(Fname_Desc),,,%IMMED Iaddress(File_Atr));
      IF Odd(Code) THEN
        Code := $Dassgn(Devchan);
      Open_File := Code;
    END; { Open_File }


  FUNCTION String(Number : [Unsafe] Unsigned) : Cuj$Varying2000;

    VAR
      X   : Integer;
      Tmp : Cuj$Varying2000;
      Ch  : Char;

    BEGIN
      Tmp := '';
      IF Number = 0 THEN
        Tmp := Tmp + '0'
       ELSE
        BEGIN
          WHILE Number <> 0 DO
            BEGIN
              Tmp := Tmp + Chr((Number MOD 10) + 48);
              Number := Number DIV 10;
            END;
          FOR X := 1 TO (Tmp.Length DIV 2) DO
            BEGIN
              Ch := Tmp.Body[X];
              Tmp.Body[X] := Tmp.Body[Tmp.Length-X+1];
              Tmp.Body[Tmp.Length-X+1] := Ch;
            END;
       END;
      String := Tmp;
    END; { String }
    

  BEGIN
    Ix := 1;
    Stat := Expand_Filename(Filename);
    IF NOT(Odd(Stat)) THEN
      Cuj$Get_File_Info := False
     ELSE
      REPEAT
        Stat := Open_File;

         (* Switch EFBLK and HIBLK words, since $QIOW reverses them *)

        Temp := File_Rat.Rat$W_Ebk0;
        File_Rat.Rat$W_Ebk0 := File_Rat.Rat$W_Ebk2;
        File_Rat.Rat$W_Ebk2 := Temp;

        Temp := File_Rat.Rat$W_Hbk0;
        File_Rat.Rat$W_Hbk0 := File_Rat.Rat$W_Hbk2;
        File_Rat.Rat$W_Hbk2 := Temp;
        WITH File_Record_Info[Ix] DO
          BEGIN
            Filename := Res_Exp_Str;
            File_Id := '(' + String(File_Fib.Fib$W_Fid[1]) + ',' + String(File_Fib.Fib$W_Fid[2]) + ',' + String(File_Fib.Fib$W_Fid[3]) + ')';
            Directory_Id := '(' + String(File_Fib.Fib$W_Did[1]) + ',' + String(File_Fib.Fib$W_Did[2]) + ',' + String(File_Fib.Fib$W_Did[3]) + ')';
            Eof_Vbn := File_Rat.Rat$L_Ebk;
            Hav := File_Rat.Rat$L_Hbk;
            Ffb := File_Rat.Rat$W_Ffb;
            Deq := File_Rat.Rat$W_Dxq;
            Gbc := File_Rat.Rat$W_Gbc;
            Fvl := File_Fib.Fib$W_Verlimit;
            Rev := Revisions;
            IF (Cdate.L0 = 0) AND (Cdate.L1 = 0) THEN
              Tdate := '<none specified>'
             ELSE
              $Asctim(Tdate.Length, Tdate.Body, Cdate);
            Cdt := Tdate;
            IF (Rdate.L0 = 0) AND (Rdate.L1 = 0) THEN
              Tdate := '<none specified>'
             ELSE
              $Asctim(Tdate.Length, Tdate.Body, Rdate);
            Rdt := Tdate;
            IF (Edate.L0 = 0) AND (Edate.L1 = 0) THEN
              Tdate := '<none specified>'
             ELSE
              $Asctim(Tdate.Length, Tdate.Body, Edate);
            Edt := Tdate;
            IF (Bdate.L0 = 0) AND (Bdate.L1 = 0) THEN
              Tdate := '<none specified>'
             ELSE
              $Asctim(Tdate.Length, Tdate.Body, Bdate);
            Bdt := Tdate;
            Prt := '(';
            IF Prots.Prot$V_Sys <> 15 THEN
              Prt := Prt + Prot_Str[Prots.Prot$V_Sys];
            Prt := Prt + ',';
            IF Prots.Prot$V_Own <> 15 THEN
              Prt := Prt + Prot_Str[Prots.Prot$V_Own];
            Prt := Prt + ',';
            IF Prots.Prot$V_Grp <> 15 THEN
              Prt := Prt + Prot_Str[Prots.Prot$V_Grp];
            Prt := Prt + ',';
            IF Prots.Prot$V_Wld <> 15 THEN
              Prt := Prt + Prot_Str[Prots.Prot$V_Wld];
            Prt := Prt + ')';
            Uic := '[' + Oct(Uicc.Uicc$W_Grp, 3, 3) + ',' + Oct(Uicc.Uicc$W_Mbm, 3, 3) + ']';
            Rat := '';
            IF File_Rat.Rat$V_Ftn THEN
              Rat := Rat + 'FORTRANCC, '
             ELSE
              Rat := Rat + 'NOFORTRANCC, ';
            IF File_Rat.Rat$V_Cr THEN
              Rat := Rat + 'IMPLIEDCC, '
             ELSE
              Rat := Rat + 'NOIMPLIEDCC, ';
            IF File_Rat.Rat$V_Prn THEN
              Rat := Rat + 'PRINTCC, '
             ELSE
              Rat := Rat + 'NOPRINTCC, ';
            IF File_Rat.Rat$V_Blk THEN
              Rat := Rat + 'NOSPAN'
             ELSE
              Rat := Rat + 'SPAN';
            Rft := Recrfm_Str[File_Rat.Rat$V_Rfm];
            Org := Filorg_Str[File_Rat.Rat$V_Org];
            IF (File_Rat.Rat$V_Org = Fab$C_Seq) AND (File_Rat.Rat$V_Rfm <> Fab$C_Fix) THEN
              Typ := 'TEXT'
             ELSE
              Typ := 'BINARY';
            Acl := '';
            IF Ace.Ace$V_Read THEN
              Acl := Acl + 'R';
            IF Ace.Ace$V_Write THEN
              Acl := Acl + '+W';
            IF Ace.Ace$V_Execute THEN
              Acl := Acl + '+E';
            IF Ace.Ace$V_Delete THEN
              Acl := Acl + '+D';
            IF Ace.Ace$V_Control THEN
              Acl := Acl + '+C';
            IF Acl = '' THEN
              Acl := 'NONE';
            Fhi[1] := File_Header.Fhd$B_Id;
            Fhi[2] := File_Header.Fhd$B_Map;
            Fhi[3] := File_Header.Fhd$B_Acl;
            Fhi[4] := File_Header.Fhd$B_Res;
          END;
        Number_Of_Files := Ix;
        Ix := Ix + 1;
        Cuj$Get_File_Info := Odd(Stat);
        Stat := Expand_Filename(Chr(0));
      UNTIL NOT(Odd(Stat)) OR (Ix > $B);
  END; { Cuj$Get_File_Info }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                            CUJ$FLUSH_KEYBOARD                             *)
(*                                                                           *)
(*   This function will cancel any input contained in the keyboard buffer.   *)
(* CUJ$FLUSH_KEYBOARD is similar to SMG$CANCEL_INPUT.  This has been provi-  *)
(* by Peter C. Conover.                                                      *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Flush_Keyboard : Cuj$Bit;

  VAR
    Kb_Chan : [Static] Cuj$Uword;
    Trash   : [Static] Cuj$Packed255;

  BEGIN
    $Assign('SYS$INPUT', Kb_Chan);
    REPEAT
      Trash[1] := Chr(0);
      $Qio(Chan := Kb_Chan, Func := Io$_Readvblk+Io$M_Noecho+Io$M_Nowait, P1 := Trash, P2 := 255);
    UNTIL Trash[1] = Chr(0);
    $Dassgn(Kb_Chan);
    Cuj$Flush_Keyboard := True;
  END; { Cuj$Flush_Keyboard }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$GET_FOREIGN                               *)
(*                                                                           *)
(*   This function will get the parameters from the DCL command line in      *)
(* which each array element contains each parameter passed.                  *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_Foreign(VAR Parameter_List : ARRAY [$A..$B:Integer] OF VARYING [$L] OF Char;
                         Prompt_String : PACKED ARRAY [$C..$D:Integer] OF Char := Chr(0);
                         Parameter_Delimiter : Char := Chr(Cuj$Space)) : Cuj$Bit;

  VAR
    Str,
    Tmp  : [Automatic] Cuj$Varying2000;
    X    : [Automatic] Integer;

  BEGIN
    IF Prompt_String <> Chr(0) THEN
      Lib$Get_Foreign(Tmp.Body, Prompt_String, Tmp.Length)
     ELSE
      Lib$Get_Foreign(Tmp.Body,,Tmp.Length);
    FOR X := 1 TO Tmp.Length DO
      IF Tmp.Body[X] = '"' THEN
        Tmp.Body[X] := ' ';
    Tmp := Cuj$Edit(Tmp, Cuj$C_Compress+Cuj$C_Trim);
    X := 1;
    IF Index(Tmp, ' ') = 0 THEN
      BEGIN
        Parameter_List[X] := Tmp;
        FOR X := 2 TO $B DO
          Parameter_List[X] := '';
      END
     ELSE
      REPEAT
        Str := Cuj$Element(Tmp, Parameter_Delimiter, X-1);
        IF Str <> '' THEN
          Parameter_List[X] := Str;
        X := X + 1;
      UNTIL (X > $B) OR (Str = '');
    Cuj$Get_Foreign := True;
  END; { Cuj$Get_Foreign }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                            CUJ$GET_IMAGE_NAME                             *)
(*                                                                           *)
(*   This function will return the name of ther image currently being ac-    *)
(* cessed.                                                                   *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_Image_Name(Flag : Integer := Cuj$C_Normal) : Cuj$Varying255;

  VAR
    Over : [Automatic] Integer;
    Dir  : [Automatic] Cuj$Varying255;

  BEGIN
    Lib$Getjpi(Jpi$_Imagname,,,,Dir.Body, Dir.Length);
    IF Flag <> Cuj$C_Normal THEN
      BEGIN
        Over := Dir.Length;
        WHILE NOT(Dir.Body[Over] IN [':', ']']) AND (Over > 1) DO
          Over := Over - 1;
        CASE Flag OF
          Cuj$C_Filename  : Dir := Substr(Dir, Over+1, Dir.Length-Over);
          Cuj$C_Directory : Dir := Substr(Dir, 1, Over);
        END;
      END;
    Cuj$Get_Image_Name := Dir;
  END; { Cuj$Get_Image_Name }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$GET_MESSAGE                               *)
(*                                                                           *)
(*   This function will return the username, nodename, message, the user who *)
(* sent e-mail, and message type.  If the username or nodename is unknown,   *)
(* CUJ$GET_MESSAGE will return it as blank.  If the nodename is local,       *)
(* CUJ$GET_MESSAGE will return the translation for the logical 'SYS$NODE',   *)
(* excluding '::'.  SMG$GET_BROADCAST_MESSAGE is internally called before    *)
(* the message string is parsed.                                             *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_Message(Pasteboard_Id : [Volatile] Unsigned;
                         VAR Record_Info : [Volatile] Cuj$Message_Type) : Cuj$Bit;

  VAR
    Mes              : [Static] Cuj$Varying255;
    Lineidx, Cidx,
    Opidx, Cpidx,
    Midx, Bidx       : [Static] Integer;
    User             : [Static] Cuj$Varying12;
    Node             : [Static] Cuj$Varying10;
    Talk_Invitation,
    User_Broadcast,
    Mail_Message     : [Automatic] Cuj$Bit;
    Lnm              : [Automatic] Cuj$Varying255;
    Itmlst           : [Automatic]
                       RECORD
                         Buflen,
                         Itmcod  : Cuj$Uword;
                         Bufadr,
                         Lenadr,
                         Termin  : Unsigned;
                       END;

  BEGIN
    Mes := '';
    Smg$Get_Broadcast_Message(Pasteboard_Id, Mes.Body, Mes.Length);
    Mes := Cuj$Edit(Mes, Cuj$C_Ascii+Cuj$C_Trim);
    Mail_Message := Index(Mes, 'New mail on') = 1;
    User_Broadcast := Index(Mes, 'Broadcast received from user') = 1;
    Talk_Invitation := Index(Mes, 'Message from TALK') = 1;
    Record_Info.Mail_User := '';
    Cidx := Index(Mes, '::');
    Opidx := Index(Mes, '(');
    Cpidx := Index(Mes, ')');
    Bidx := Index(Mes, '[');
    Midx := Index(Mes, '-');
    IF NOT(Translated) THEN
      BEGIN
        Lnm := '';
        Itmlst.Buflen := Lnm$C_Namlength;
        Itmlst.Itmcod := Lnm$_String;
        Itmlst.Bufadr := Iaddress(Lnm.Body);
        Itmlst.Lenadr := Iaddress(Lnm.Length);
        Itmlst.Termin := 0;
        $Trnlnm(Attr := Lnm$M_Case_Blind, Tabnam := Cuj$T_System, Lognam := 'SYS$NODE', Itmlst := Itmlst);
        Local_Node := Cuj$Element(Lnm, ':');
        Translated := True;
      END;
    IF Opidx = 1 THEN
      BEGIN (* Outside or System Message *)
        IF Cpidx+2 = Midx THEN
          BEGIN
            User := ''; (* System Message *)
            Record_Info.Message_Type := Cuj$C_System;
          END
         ELSE
          BEGIN
            User := Substr(Mes, Cpidx+1, Midx-Cpidx-2); (* Outside Message *)
            Record_Info.Message_Type := Cuj$C_Bitnet;
          END;
        Node := Substr(Mes, Opidx+1, Cpidx-Opidx-1);
        Mes := Substr(Mes, Midx+2, Mes.Length-Midx-1);
      END
     ELSE
      IF (Cidx > 1) AND (Cidx < 10) AND (Cidx < Opidx) AND (Midx-2 = Cpidx) THEN
        BEGIN (* DECNET Message *)
          User := Cuj$Edit(Substr(Mes, Cidx+2, Opidx-Cidx-2), Cuj$C_Trim);
          Node := Cuj$Element(Mes, ':') + '::';
          Mes := Substr(Mes, Midx+2, Mes.Length-Midx-1);
          Record_Info.Message_Type := Cuj$C_Decnet;
        END
       ELSE
        IF (Opidx > 1) AND (Opidx < 14) THEN
          BEGIN (* Local Message *)
            User := Cuj$Element(Mes, '(');
            Node := Cuj$Edit(Local_Node, Cuj$C_Trim);
            Record_Info.Message_Type := Cuj$C_Local;
            Mes := Substr(Mes, Midx+2, Mes.Length-Midx-1);
          END
         ELSE
          IF Mail_Message THEN
            BEGIN (* Mail Message *)
              Mes := Substr(Mes, 18, Mes.Length-17);
              User := '';
              Node := Cuj$Element(Mes, ' ');
              Record_Info.Mail_User := Cuj$Element(Cuj$Edit(Mes, Cuj$C_Compress), ' ', 2);
              Mes := '';
              Record_Info.Message_Type := Cuj$C_Mail;
            END
           ELSE
            IF User_Broadcast THEN
              BEGIN (* USERnn Broadcast *)
                User := Cuj$Element(Cuj$Edit(Mes, Cuj$C_Compress), ' ', 4);
                Node := '';
                Lineidx := Index(Mes, Chr(10)) + 1;
                Mes := Substr(Mes, Lineidx, Mes.Length-Lineidx+1);
                Record_Info.Message_Type := Cuj$C_User;
              END
             ELSE
              IF Talk_Invitation THEN
                BEGIN
                  User := '';
                  Node := '';
                  Mes := Substr(Mes, Bidx, Mes.Length-Bidx);
                  Record_Info.Mail_User := Cuj$Element(Mes, ' ', 3);
                  Record_Info.Message_Type := Cuj$C_Talk;
                  Mes := '';
                END
               ELSE
                BEGIN (* Unknown Broadcast *)
                  User := '';
                  Node := '';
                  Record_Info.Message_Type := Cuj$C_Unknown;
                END;
    Record_Info.Username := User;
    Record_Info.Nodename := Node;
    Record_Info.Message := Mes;
    Cuj$Get_Message := True;
  END; { Cuj$Get_Message }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                              CUJ$GET_OPTION                               *)
(*                                                                           *)
(*   This function will allow a user to select from an array of options by   *)
(* using the first letter of each option or with the arrow keys.  The option *)
(* selected is returned.  CUJ$GET_OPTION will return FALSE if the prompt     *)
(* string or the width of the options is too long to fit in a display row,   *)
(* or the terminator is one of the first letters in the options.             *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_Option(Display_Id, Keyboard_Id : [Volatile] Unsigned;
                        Display_Row, Display_Column : Integer := 1;
                        Prompt_String : PACKED ARRAY [$A..$B:Integer] OF Char := 'Options';
                        Options : ARRAY [$C..$D:Integer] OF VARYING [$L] OF Char;
                        VAR Selected_Option : VARYING [$L2] OF Char;
                        Terminator : Cuj$Uword := Cuj$Return;
                        Default_Position : Integer := 1;
                        Prompt_Rendition : Unsigned := Smg$M_Normal;
                        Character_Rendition : Unsigned := Smg$M_Reverse;
                        String_Rendition : Unsigned := Smg$M_Normal;
                        Enclosures : Cuj$Packed2 := '[]';
                        Delimiter : Char := '/';
                        Prompt_End : Char := ':';
                        Flags : Unsigned := Cuj$C_Normal) : Cuj$Bit;

  VAR
    Keyword   : [Automatic] Cuj$Uword;
    X, X1,
    Old_X,
    Mark, Tmp : [Automatic] Integer;
    Up, Low,
    Found     : [Automatic] Cuj$Bit;

  BEGIN
    Stat := Smg$Put_Chars(Display_Id, Prompt_String, Display_Row, Display_Column,,,Prompt_Rendition);
    Found := False;
    X := $C;
    REPEAT
      IF Options[X].Body[1] = Chr(Terminator) THEN
        Found := True
       ELSE
        X := X + 1;
    UNTIL Found OR (X > $D);
    IF NOT(Odd(Stat)) OR Found THEN
      Cuj$Get_Option := False
     ELSE
      BEGIN
        Tmp := $B + 1;
        IF Prompt_String = Chr(0) THEN
          Tmp := 0;
        Up := Uand(Flags, Cuj$C_Upcase) = Cuj$C_Upcase;
        Low := Uand(Flags, Cuj$C_Lowercase) = Cuj$C_Lowercase;
        FOR X := $C TO $D DO
          IF Up AND (Options[X].Body[1] IN ['a'..'z']) THEN
            Options[X].Body[1] := Chr(Ord(Options[X].Body[1])-32)
           ELSE
            IF Low AND (Options[X].Body[1] IN ['A'..'Z']) THEN
              Options[X].Body[1] := Chr(Ord(Options[X].Body[1])+32);
        Smg$Put_Chars(Display_Id, Enclosures[1]+Options[1].Body[1], Display_Row, Display_Column+Tmp,,,Prompt_Rendition);
        FOR X := 2 TO $D DO
          BEGIN
            X1 := X * 2 - 2;
            Smg$Put_Chars(Display_Id, Delimiter+Options[X].Body[1], Display_Row, Display_Column+Tmp+X1,,,Prompt_Rendition);
          END;
        Mark := Display_Column + Tmp + 5 + X1;
        Smg$Put_Chars(Display_Id, Enclosures[2]+Prompt_End, Display_Row, Display_Column+Tmp+2+X1,,,Prompt_Rendition);
        Smg$Begin_Display_Update(Display_Id);
        Smg$Put_Chars(Display_Id, Options[Default_Position], Display_Row, Mark,,,String_Rendition);
        Smg$Change_Rendition(Display_Id, Display_Row, Mark, 1, 1, Character_Rendition);
        Smg$Set_Cursor_Abs(Display_Id, Display_Row, Mark);
        Smg$End_Display_Update(Display_Id);
        Smg$Cancel_Input(Keyboard_Id);
        X := Default_Position;
        REPEAT
          Smg$Read_Keystroke(Keyboard_Id, Keyword);
          IF Up AND (Chr(Keyword) IN ['a'..'z']) THEN
            Keyword := Keyword - 32
           ELSE
            IF Low AND (Chr(Keyword) IN ['A'..'Z']) THEN
              Keyword := Keyword + 32;
          Found := False;
          CASE Keyword OF
            Cuj$Up_Arrow, Cuj$Left_Arrow    : BEGIN
                                                X := X - 1;
                                                IF X < 1 THEN
                                                  X := $D;
                                                Found := True;
                                              END;
            Cuj$Down_Arrow, Cuj$Right_Arrow : BEGIN
                                                X := X + 1;
                                                IF X > $D THEN
                                                  X := 1;
                                                Found := True;
                                              END;
          OTHERWISE
            IF Keyword <> Terminator THEN
              BEGIN
                Old_X := X;
                X := 1;
                REPEAT
                  IF Chr(Keyword) = Options[X].Body[1] THEN
                    Found := True
                   ELSE
                    X := X + 1;
                UNTIL Found OR (X > $D);
              END;
          END;
          IF NOT(Found) AND (Keyword <> Terminator) THEN
            BEGIN
              Smg$Ring_Bell(Display_Id);
              X := Old_X;
            END
           ELSE
            IF Keyword <> Terminator THEN
              BEGIN
                Smg$Begin_Display_Update(Display_Id);
                Smg$Erase_Display(Display_Id, Display_Row, Mark, Display_Row, Mark+$L-1);
                Smg$Put_Chars(Display_Id, Cuj$Edit(Options[X], Cuj$C_Trim), Display_Row, Mark,,,String_Rendition);
                Smg$Change_Rendition(Display_Id, Display_Row, Mark, 1, 1, Character_Rendition);
                Smg$Set_Cursor_Abs(Display_Id, Display_Row, Mark);
                Smg$End_Display_Update(Display_Id);
              END;
        UNTIL Keyword = Cuj$Return;
        Selected_Option := Options[X];
        Cuj$Get_Option := True;
      END;
  END; { Cuj$Get_Option }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                               CUJ$GET_QUOTA                               *)
(*                                                                           *)
(*   This function will get the user's own quota.  CUJ$GET_QUOTA will return *)
(* FALSE if the quota could not be obtained for the device.  This function   *)
(* is similar to the DCL command SHOW QUOTA.                                 *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_Quota(Device : VARYING [$L] OF Char := 'SYS$DISK';
                       VAR Quota_Info : Cuj$Quota_Type) : Cuj$Bit;

  TYPE
    Dqf$Type        = RECORD
                        Dqf$L_Flags,
                        Dqf$L_Uic,
                        Dqf$L_Usage,
                        Dqf$L_Permquota,
                        Dqf$L_Overdraft,
                        Dqf$L_Reserved1,
                        Dqf$L_Reserved2,
                        Dqf$L_Reserved3  : Integer;
                      END;
    Dqf$Type_Descr  = RECORD
                        Len,
                        Null : Cuj$Uword;
                        Buff : Integer;
                      END;
    Fib1$Type_Descr = RECORD
                        Len,
                        Null : Cuj$Uword;
                        Buff : Integer;
                      END;

  VAR
    Chan            : Cuj$Uword;
    Uic             : Integer;
    Fib_Descr       : Fib1$Type_Descr;
    Fib             : Fib1$Type;
    In_Block_Descr,
    Out_Block_Descr : Dqf$Type_Descr;
    In_Block,
    Out_Block       : Dqf$Type;

  BEGIN
    Lib$Getjpi(Jpi$_Uic,,,Uic);
    Fib.Fib$W_Cntrlfunc := Fib$C_Exa_Quota;
    In_Block.Dqf$L_Flags := Zero;
    In_Block.Dqf$L_Uic := Uic;
    Stat := $Assign(Device, Chan);
    IF NOT(Odd(Stat)) THEN
      Cuj$Get_Quota := False
     ELSE
      BEGIN
        In_Block_Descr.Len := 32;
        Out_Block_Descr.Len := 32;
        In_Block_Descr.Buff := Iaddress(In_Block);
        Out_Block_Descr.Buff := Iaddress(Out_Block);
        Fib_Descr.Len := 64;
        Fib_Descr.Buff := Iaddress(Fib);
        Stat := $Qiow(Chan := Chan, Func := Io$_Acpcontrol, P1 := Fib_Descr, P2 := Iaddress(In_Block_Descr), P4 := Iaddress(Out_Block_Descr));
        IF NOT(Odd(Stat)) THEN
          Cuj$Get_Quota := False
         ELSE
          BEGIN
            Quota_Info.Quota_Limit := Out_Block.Dqf$L_Permquota;
            Quota_Info.Quota_Used := Out_Block.Dqf$L_Usage;
            Quota_Info.Quota_Remain := Quota_Info.Quota_Limit - Quota_Info.Quota_Used;
            Quota_Info.Quota_Overdraft := Out_Block.Dqf$L_Overdraft;
            Cuj$Get_Quota := True;
          END;
      END;
  END; { Cuj$Get_Quota }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                              CUJ$GET_STRING                               *)
(*                                                                           *)
(*   This function will allow a user to type in a series of characters in a  *)
(* single call inside a virtual display.  The resultant string is returned.  *)
(* CUJ$GET_STRING will return FALSE if the arrow keys, CTRL_E, CTRL_H, or    *)
(* CTRL_X is a terminator, or the prompt string is too long.                 *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Get_String(Display_Id, Keyboard_Id : [Volatile] Unsigned;
                        Display_Row : Integer := 1;
                        VAR Resultant_String : [Volatile] VARYING [$L] OF Char;
                        Default_String : ARRAY [$A..$B:Integer] OF VARYING [$L2] OF Char;
                        Maximum_Length : Integer := Cuj$C_Normal;
                        Character_Rendition, Field_Rendition : Unsigned := Smg$M_Normal;
                        Terminators : PACKED ARRAY [$C..$D:Integer] OF Char := Chr(Cuj$Return)+Chr(Cuj$Ctrl_Z);
                        VAR Return_Value : [Volatile] Cuj$Uword;
                        Limiting_Set : Cuj$Character_Set := [Chr(32)..Chr(127)];
                        Flags : Unsigned := Cuj$C_Normal) : Cuj$Bit;

  VAR
    Height, Width,
    X, Cnt, Crs      : [Automatic] Integer;
    Tmp              : [Automatic] Cuj$Varying2000;
    Upcase, Lowcase,
    Center, Right,
    Rung, Exceeded   : [Automatic] Cuj$Bit;
    Keyword          : [Automatic] Cuj$Uword;


  FUNCTION Maximum_Count : Integer;

    VAR
      Idx : [Automatic] Integer;

    BEGIN
      Idx := $B + 1;
      REPEAT
        Idx := Idx - 1;
      UNTIL (Default_String[Idx] <> '') OR (Idx < 2);
      Maximum_Count := Idx;
    END; { Maximum_Count }

    
  BEGIN
    Exceeded := Uand(Flags, Cuj$C_Exceed) = Cuj$C_Exceed;
    Center := Uand(Flags, Cuj$C_Center) = Cuj$C_Center;
    Smg$Get_Display_Attr(Display_Id, Height, Width);
    IF (Index(Terminators, Chr(Cuj$Up_Arrow)) > 0) OR (Index(Terminators, Chr(Cuj$Down_Arrow)) > 0) OR
       (Index(Terminators, Chr(Cuj$Left_Arrow)) > 0) OR (Index(Terminators, Chr(Cuj$Right_Arrow)) > 0) OR
       (Index(Terminators, Chr(Cuj$Ctrl_E)) > 0) OR (Index(Terminators, Chr(Cuj$Ctrl_H)) > 0) OR
       (Index(Terminators, Chr(Cuj$Ctrl_X)) > 0) OR ((Maximum_Length > Width) AND NOT(Exceeded)) OR
       (Exceeded) AND (Center) THEN
      Cuj$Get_String := False
     ELSE
      BEGIN
        Tmp := '';
        Crs := 0;
        IF Maximum_Length = Cuj$C_Normal THEN
          Maximum_Length := Width;
        Upcase := Uand(Flags, Cuj$C_Upcase) = Cuj$C_Upcase;
        Lowcase := Uand(Flags, Cuj$C_Lowercase) = Cuj$C_Lowercase;
        Right := Uand(Flags, Cuj$C_Right_Flush) = Cuj$C_Right_Flush;
        Cnt := 0;
        X := 1;
        IF Center THEN
          X := (Width DIV 2) + 1;
        IF Right THEN
          X := Width;
        Smg$Change_Rendition(Display_Id, Display_Row, 1, 1, Maximum_Length,,Field_Rendition);
        Smg$Set_Cursor_Abs(Display_Id, Display_Row, X);
        REPEAT
          Rung := False;
          Ast_In_Progress := False;
          Smg$Read_Keystroke(Keyboard_Id, Keyword);
          CASE Keyword OF
            Cuj$Up_Arrow    : BEGIN
                                Crs := 0;
                                Cnt := Cnt + 1;
                                IF Cnt <= Maximum_Count THEN
                                  Tmp := Default_String[Cnt]
                                 ELSE
                                  BEGIN
                                    Cnt := 0;
                                    Tmp := '';
                                  END;
                              END;
            Cuj$Down_Arrow  : BEGIN
                                Crs := 0;
                                Cnt := Cnt - 1;
                                IF Cnt >= 1 THEN
                                  Tmp := Default_String[Cnt]
                                 ELSE
                                  BEGIN
                                    Cnt := Maximum_Count + 1;
                                    Tmp := '';
                                  END;
                              END;
            Cuj$Left_Arrow  : IF Crs < Tmp.Length THEN
                                Crs := Crs + 1
                               ELSE
                                Rung := True;
            Cuj$Right_Arrow : IF Crs > 0 THEN
                                Crs := Crs - 1
                               ELSE
                                Rung := True;
            Cuj$Delete      : IF Tmp.Length-Crs > 0 THEN
                                BEGIN
                                  FOR X := Tmp.Length-Crs TO Tmp.Length-1 DO
                                    Tmp.Body[X] := Tmp.Body[X+1];
                                  Tmp.Length := Tmp.Length - 1;
                                END
                               ELSE
                                Rung := True;
            Cuj$Ctrl_E      : IF Crs > 0 THEN
                                Crs := 0
                               ELSE
                                Rung := True;
            Cuj$Ctrl_H      : IF Crs < Tmp.Length THEN
                                Crs := Tmp.Length
                               ELSE
                                Rung := True;
            Cuj$Ctrl_U      : IF Tmp.Length-Crs > 0 THEN
                                Tmp := Substr(Tmp, Tmp.Length-Crs+1, Crs)
                               ELSE
                                Rung := True;
          OTHERWISE
            IF (((Tmp.Length < $L) AND Exceeded) OR (Tmp.Length < Maximum_Length)) AND (Chr(Keyword) IN Limiting_Set) THEN
              BEGIN
                IF Upcase AND (Chr(Keyword) IN ['a'..'z']) THEN
                  Keyword := Keyword - 32;
                IF Lowcase AND (Chr(Keyword) IN ['A'..'Z']) THEN
                  Keyword := Keyword + 32;
                IF Index(Terminators, Chr(Keyword)) = 0 THEN
                  BEGIN
                    Tmp.Length := Tmp.Length + 1;
                    FOR X := Tmp.Length DOWNTO Tmp.Length-Crs+1 DO
                      Tmp.Body[X] := Tmp.Body[X-1];
                    Tmp.Body[Tmp.Length-Crs] := Chr(Keyword);
                  END;
              END
             ELSE
              IF Index(Terminators, Chr(Keyword)) = 0 THEN
                Rung := True;
          END;
          X := Tmp.Length + 1;
          IF Center THEN
            X := ((Width - Tmp.Length) DIV 2) + 1;
          IF Right THEN
            X := Width - Tmp.Length + 1;
          IF (Index(Terminators, Chr(Keyword)) = 0) AND NOT(Rung) THEN
            BEGIN
              Smg$Begin_Display_Update(Display_Id);
              Smg$Erase_Display(Display_Id, Display_Row, 1, Display_Row, Maximum_Length);
              Smg$Change_Rendition(Display_Id, Display_Row, 1, 1, Maximum_Length,,Field_Rendition);
              IF Center OR Right THEN
                Smg$Put_Chars(Display_Id, Substr(Tmp, 1, Tmp.Length), Display_Row, X,,,Character_Rendition)
               ELSE
                IF Exceeded AND (Tmp.Length-Crs > Width) THEN
                  Smg$Put_Chars(Display_Id, Substr(Tmp, Tmp.Length-Width+1-Crs, Width), Display_Row, 1,,,Character_Rendition)
                 ELSE
                  Smg$Put_Chars(Display_Id, Substr(Tmp, 1, Tmp.Length), Display_Row, 1,,,Character_Rendition);
              X := Tmp.Length + 1;
              IF Center THEN
                X := ((Width - Tmp.Length) DIV 2) + Tmp.Length + 1;
              IF Right THEN
                X := Width;
              Smg$Set_Cursor_Abs(Display_Id, Display_Row, X-Crs);
              Smg$End_Display_Update(Display_Id);
            END
           ELSE
            IF Rung AND NOT(Ast_In_Progress) THEN
              Smg$Ring_Bell(Display_Id);
        UNTIL Index(Terminators, Chr(Keyword)) > 0;
        IF Chr(Keyword) = Terminators[1] THEN
          Resultant_String := Tmp
         ELSE
          Resultant_String := '';
        Return_Value := Keyword;
        Cuj$Get_String := True;
      END;
  END; { Cuj$Get_String }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                CUJ$INTEGER                                *)
(*                                                                           *)
(*   This function will translate a string into an integer.  CUJ$INTEGER     *)
(* will return the resultant integer.  This is similar to the DCL lexical    *)
(* function F$INTEGER.                                                       *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Integer(Text_String : VARYING [$L] OF Char) : Integer;

  VAR
    X, Expo,
    Tmp      : [Automatic] Integer;
    Negative : [Automatic] Cuj$Bit;

  BEGIN
    Tmp := 0;
    Expo := 1;
    FOR X := Text_String.Length DOWNTO 1 DO
      BEGIN
        IF Text_String.Body[X] IN ['0'..'9'] THEN
          BEGIN
            Tmp := Tmp + Expo * (Ord(Text_String.Body[X]) - 48);
            Expo := Expo * 10;
          END
         ELSE
          IF Text_String.Body[X] = '-' THEN
            Negative := True;
      END;
    IF Negative THEN
      Tmp := -Tmp;
    Cuj$Integer := Tmp;
  END; { Cuj$Integer }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                CUJ$LENGTH                                 *)
(*                                                                           *)
(*   This function will return the length of a specified string, excluding   *)
(* trailing spaces.                                                          *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Length(Text_String : VARYING [$L] OF Char) : Integer;

  VAR
    Over : [Automatic] Integer;

  BEGIN
    IF Text_String.Length = 0 THEN
      Cuj$Length := 0
     ELSE
      BEGIN
        Over := Text_String.Length;
        WHILE (Text_String.Body[Over] = ' ') AND (Over > 1) DO
          Over := Over - 1;
        Cuj$Length := Over;
      END;
  END; { Cuj$Length }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$MAKE_DISPLAY                              *)
(*                                                                           *)
(*   This function will create and paste a virtual display onto a specified  *)
(* pasteboard.  CUJ$MAKE_DISPLAY will return FALSE if the display could not  *)
(* be created or pasted, or the display could not be labeled, if any.  The   *)
(* display identifier is returned.                                           *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Make_Display(VAR Display_Id : [Volatile] Unsigned;
                          Pasteboard_Id : [Volatile] Unsigned;
                          Display_Rows, Display_Columns, Paste_Row, Paste_Column : Integer := 1;
                          Display_Rendition, Video_Attributes : Unsigned := Smg$M_Normal;
                          Border_Label : PACKED ARRAY [$A..$B:Integer] OF Char := Chr(0);
                          Label_Position : Unsigned := Smg$K_Top;
                          Label_Units : Integer := 0;
                          Label_Rendition : Unsigned := Smg$M_Normal;
                          Flags : Unsigned := Cuj$C_Normal;
                          Top_Display_Id : [Volatile] Unsigned := 0) : Cuj$Bit;

  VAR
    Screen  : [Static] Smg$Type;
    X, Cnt  : [Static] Integer;
    Border,
    Block,
    Update  : [Static] Cuj$Bit;

  BEGIN
    Update := False;
    Smg$Get_Pasteboard_Attributes(Pasteboard_Id, %REF Screen, Smg$C_Pasteboard_Info_Block);
    Stat := Smg$Create_Virtual_Display(Display_Rows, Display_Columns, Display_Id, Video_Attributes, Display_Rendition);
    IF NOT(Odd(Stat)) THEN
      Cuj$Make_Display := False
     ELSE
      BEGIN
        Cnt := 1;
        Border := Uand(Video_Attributes, Smg$M_Border) = Smg$M_Border;
        Block := Uand(Video_Attributes, Smg$M_Block_Border) = Smg$M_Block_Border;
        IF Flags <> Cuj$C_Normal THEN
          FOR X := 0 TO 4 DO
            BEGIN
              IF (Flags MOD 2) = 1 THEN
                CASE Cnt OF
                  Cuj$C_Center        : BEGIN
                                          Paste_Row := ((24 - Display_Rows) DIV 2) + 1;
                                          IF Uand(Flags, Cuj$C_80_Columns) = Cuj$C_80_Columns THEN
                                            Paste_Column := ((80 - Display_Columns) DIV 2) + 1
                                           ELSE
                                            IF Uand(Flags, Cuj$C_132_Columns) = Cuj$C_132_Columns THEN
                                              Paste_Column := ((132 - Display_Columns) DIV 2) + 1
                                             ELSE
                                              Paste_Column := ((Screen.Smg$W_Width - Display_Columns) DIV 2) + 1;
                                        END;
                  Cuj$C_Center_Row    : Paste_Row := ((24 - Display_Rows) DIV 2) + 1;
                  Cuj$C_Center_Column : IF Uand(Flags, Cuj$C_80_Columns) = Cuj$C_80_Columns THEN
                                          Paste_Column := ((80 - Display_Columns) DIV 2) + 1
                                         ELSE
                                          IF Uand(Flags, Cuj$C_132_Columns) = Cuj$C_132_Columns THEN
                                            Paste_Column := ((132 - Display_Columns) DIV 2) + 1
                                           ELSE
                                            Paste_Column := ((Screen.Smg$W_Width - Display_Columns) DIV 2) + 1;
                  Cuj$C_Right_Flush   : BEGIN
                                          IF Uand(Flags, Cuj$C_80_Columns) = Cuj$C_80_Columns THEN
                                            Paste_Column := 80 - Display_Columns + 1
                                           ELSE
                                            IF Uand(Flags, Cuj$C_132_Columns) = Cuj$C_132_Columns THEN
                                              Paste_Column := 132 - Display_Columns + 1
                                             ELSE
                                              Paste_Column := Screen.Smg$W_Width - Display_Columns + 1;
                                           IF Border OR Block THEN
                                             Paste_Column := Paste_Column - 1;
                                        END;
                  Cuj$C_Update        : Update := True;
                END;
              Flags := Flags DIV 2;
              Cnt := Cnt * 2;
            END;
        IF Update THEN
          Smg$Begin_Pasteboard_Update(Pasteboard_Id);
        IF Top_Display_Id <> 0 THEN
          Stat := Smg$Paste_Virtual_Display(Display_Id, Pasteboard_Id, Paste_Row, Paste_Column, Top_Display_Id)
         ELSE
          Stat := Smg$Paste_Virtual_Display(Display_Id, Pasteboard_Id, Paste_Row, Paste_Column);
        IF NOT(Odd(Stat)) THEN
          Cuj$Make_Display := False
         ELSE
          BEGIN
            IF Border_Label <> Chr(0) THEN
              IF Label_Units = 0 THEN
                Stat := Smg$Label_Border(Display_Id, Border_Label, Label_Position,,Label_Rendition)
               ELSE
                Stat := Smg$Label_Border(Display_Id, Border_Label, Label_Position, Label_Units, Label_Rendition);
            Cuj$Make_Display := Odd(Stat);
          END;
        IF Update THEN
          Smg$End_Pasteboard_Update(Pasteboard_Id);
      END;
  END; { Cuj$Make_Display }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                 CUJ$MENU                                  *)
(*                                                                           *)
(*   This function will create a menu and allow the user to select from it   *)
(* in a virtual display by using the arrow, Prev Scrn, and Next Scrn keys.   *)
(* The display must already be pasted on the pasteboard.  If a selection is  *)
(* not made, the selected choice will be returned as blank.  CUJ$MENU will   *)
(* return FALSE if the selections are too long to fit in a display row or    *)
(* there are no selections to choose from.                                   *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Menu(Display_Id, Pasteboard_Id, Keyboard_Id : [Volatile] Unsigned;
                  Choices : ARRAY [$A..$B:Integer] OF VARYING [$L] OF Char;
                  VAR Selected_Choice : [Volatile] VARYING [$L2] OF Char;
                  Choices_Rendition : Unsigned := Smg$M_Normal;
                  Selecting_Rendition : Unsigned := Smg$M_Reverse;
                  Default_Position : Integer := 1;
                  VAR Resultant_Position : Integer;
                  Help_Library : PACKED ARRAY [$G..$H:Integer] OF Char := 'SYS$HELP:HELPLIB.HLB';
                  Terminators : PACKED ARRAY [$I..$J:Integer] OF Char := Chr(Cuj$Return)+Chr(Cuj$Ctrl_Z);
                  VAR Return_Value : [Volatile] Cuj$Uword;
                  Flags : Unsigned := Cuj$C_Normal) : Cuj$Bit;

  VAR
    Hlp                 : [Automatic] Unsigned;
    X, Y, Xm, Height,
    Width, Half, Mark,
    Wrapx, Cnt, Step,
    Remain, Max, Num,
    Diff, Oldx, Maxchs,
    Maxwidth{, Maxm}    : [Automatic] Integer;
    Keyword             : [Automatic] Cuj$Uword;
    Wrapped, Fixed,
    Updated, Blocked,
    Horizontal, More,
    Right, Center       : [Automatic] Cuj$Bit;

  BEGIN
    Smg$Get_Display_Attr(Display_Id, Height, Width);
    Maxwidth := 0;
    Maxchs := $B;
    IF Maxchs = 0 THEN
      Cuj$Menu := False
     ELSE
      BEGIN
        WHILE (Cuj$Edit(Choices[Maxchs], Cuj$C_Trim) = '') AND (Maxchs > 1) DO
          Maxchs := Maxchs - 1;
        FOR X := 1 TO Maxchs DO
          IF Choices[X].Length > Maxwidth THEN
            Maxwidth := Choices[X].Length;
        IF Maxwidth > Width THEN
          Cuj$Menu := False
         ELSE
          BEGIN
            IF Default_Position > Maxchs THEN
              Default_Position := Maxchs;
            Right := Uand(Flags, Cuj$C_Right_Flush) = Cuj$C_Right_Flush;
            Center := Uand(Flags, Cuj$C_Center) = Cuj$C_Center;
            Half := Round(Height/2);
            X := 1;
            {Maxm := 1;}
            Mark := 1;
            Cnt := 1;
            Y := 1;
            Diff := Maxwidth + 2;
            Num := 1;
            Max := 0;
            Remain := Height MOD 2;
            Fixed := Uand(Flags, Cuj$C_Fixed) = Cuj$C_Fixed;
            Wrapped := Uand(Flags, Cuj$C_Wrap) = Cuj$C_Wrap;
            Updated := Uand(Flags, Cuj$C_Update) = Cuj$C_Update;
            Blocked := Uand(Flags, Cuj$C_Block) = Cuj$C_Block;
            Horizontal := Uand(Flags, Cuj$C_Horizontal) = Cuj$C_Horizontal;
            Smg$Begin_Display_Update(Display_Id);
            Smg$Erase_Display(Display_Id);
            IF Blocked THEN
              BEGIN
                REPEAT
                  REPEAT
                    Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[Cnt], Cuj$C_Trim), Mark, X,,,Choices_Rendition);
                    Cnt := Cnt + 1;
                    X := X + Diff;
                  UNTIL (Cnt > Maxchs) OR (X+Maxwidth > Width);
                  IF Num = 1 THEN
                    BEGIN
                      Num := Cnt - 1;
                      Max := X - Maxwidth - 2;
                    END;
                  Mark := Mark + 1;
                  X := 1;
                UNTIL (Mark > Height) OR (Cnt > Maxchs);
                More := (Mark > Height) AND (Cnt-1 < Maxchs);
                Mark := 1;
                Wrapx := Max;
                IF Maxchs MOD Num > 0 THEN
                  REPEAT
                    Wrapx := Wrapx - Maxwidth - 2;
                  UNTIL (Wrapx DIV Diff+1) = Maxchs MOD Num;
                Smg$Change_Rendition(Display_Id, Y, X, Y, Choices[1].Length,,Selecting_Rendition);
              END
             ELSE
              IF Horizontal THEN
                BEGIN
                  REPEAT
                    Smg$Erase_Display(Display_Id);
                    X := 1;
                    REPEAT
                      Smg$Put_Chars(Display_Id, Choices[Cnt], Y, X,,,Choices_Rendition);
                      Cnt := Cnt + 1;
                      X := X + Diff;
                      IF Num = 1 THEN
                        Max := X - Maxwidth - 2;
                    UNTIL X+Maxwidth > Width;
                    Num := Num + 1;
                  UNTIL (Cnt > Maxchs) OR (Cnt > Default_Position);
                  More := Cnt-1 < Maxchs;
                  Num := Cnt - 1;
                  Cnt := 1;
                  Y := 1;
                  X := Default_Position;
                  Mark := 1;
                  Xm := (X * Diff) - (Diff - 1);
                  Wrapx := Max;
                  IF Maxchs MOD Num > 0 THEN
                    REPEAT
                      Wrapx := Wrapx - Maxwidth - 2;
                    UNTIL Wrapx DIV Diff+1 = Maxchs MOD Num;
                  Smg$Change_Rendition(Display_Id, Y, Xm, Y, Choices[1].Length,,Selecting_Rendition);
                END
               ELSE
                BEGIN

(* The REPEAT-UNTIL loop will eventually be applied to all three menu types *)

                  IF Default_Position > 1 THEN
                    REPEAT
                      IF NOT((Mark = Half) AND (Maxchs > Height) AND (X < Maxchs-Half+Remain)) THEN
                        Mark := Mark + 1;
                      X := X + 1;
                    UNTIL X >= Default_Position;
                  Oldx := X;
                  Y := Mark;
                  Xm := 1;
                  REPEAT
                    IF Right THEN
                      Xm := Width - Choices[X].Length + 1;
                    IF Center THEN
                      Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                    Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                    Mark := Mark - 1;
                    X := X - 1;
                  UNTIL (Mark < 1) OR (X < 1);
                  X := Oldx + 1;
                  Mark := Y + 1;
                  IF (Mark <= Height) AND (X <= Maxchs) THEN
                    REPEAT
                      IF Right THEN
                        Xm := Width - Choices[X].Length + 1;
                      IF Center THEN
                        Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                      Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                      Mark := Mark + 1;
                      X := X + 1;
                    UNTIL (Mark > Height) OR (X > Maxchs);
                  X := Oldx;
                  Mark := Y;
                  IF Right THEN
                    Xm := Width - Choices[X].Length + 1;
                  IF Center THEN
                    Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                  IF Fixed THEN
                    Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                   ELSE
                    Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Selecting_Rendition);
                  Cnt := 1;
                  Xm := 1;
                  IF Right THEN
                    Xm := Width - Choices[X].Length + 1;
                  IF Center THEN
                    Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                END;
            Smg$Set_Cursor_Abs(Display_Id, Mark, Xm);
            Smg$End_Display_Update(Display_Id);
            Smg$Cancel_Input(Keyboard_Id);
            REPEAT
              Smg$Read_Keystroke(Keyboard_Id, Keyword);
              CASE Keyword OF
                Cuj$Ctrl_H, Cuj$Help : BEGIN
                                         Cuj$Make_Display(Hlp, Pasteboard_Id, 24, 80, 1, 1);
                                         Stat := Smg$Put_Help_Text(Hlp, Keyboard_Id, Choices[X], Help_Library);
                                         IF NOT(Odd(Stat)) THEN
                                           BEGIN
                                             Smg$Set_Cursor_Mode(Hlp, Smg$M_Cursor_Off);
                                             Smg$Put_Chars(Hlp, 'Unable to open help library file', 11, 23,,,Smg$M_Bold);
                                             Smg$Put_Chars(Hlp, 'Hit any key to continue', 12, 28,,,Smg$M_Bold);
                                             Smg$Read_Keystroke(Keyboard_Id, Keyword);
                                             Smg$Set_Cursor_Mode(Hlp, Smg$M_Cursor_On);
                                           END;
                                         Smg$Delete_Virtual_Display(Hlp);
                                         Keyword := 256;
                                       END;
                Cuj$Up_Arrow         : IF Blocked THEN
                                         IF False THEN
                                           BEGIN
                                           END
                                          ELSE
                                           IF Wrapped THEN
                                             BEGIN
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                               X := Maxchs;
                                               Oldx := Xm;
                                               Xm := Wrapx;
                                               Mark := Maxchs DIV Num;
                                               IF Maxchs MOD Num > 0 THEN
                                                 Mark := Mark + 1;
                                               IF More THEN
                                                 BEGIN
                                                   Smg$Begin_Display_Update(Display_Id);
                                                   Smg$Erase_Display(Display_Id);
                                                   Cnt := X;
                                                   Mark := Height;
                                                   REPEAT
                                                     REPEAT
                                                       Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[Cnt], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                       Cnt := Cnt - 1;
                                                       Xm := Xm - Maxwidth - 2;
                                                     UNTIL (Xm < 1) OR (Cnt < 1);
                                                     Xm := Max;
                                                     Mark := Mark - 1;
                                                   UNTIL Mark < 1;
                                                   Smg$End_Display_Update(Display_Id);
                                                   Mark := Height;
                                                 END;
                                               Xm := Oldx;
                                               IF Xm <> Wrapx THEN
                                                 BEGIN
                                                   Xm := Wrapx;
                                                   REPEAT
                                                     REPEAT
                                                       X := X - 1;
                                                       Xm := Xm - Maxwidth - 2;
                                                     UNTIL (Xm < 1) OR (Xm = Oldx);
                                                     IF Xm <> Oldx THEN
                                                       BEGIN
                                                         Mark := Mark - 1;
                                                         Xm := Max;
                                                       END;
                                                   UNTIL Xm = Oldx;
                                                 END;
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                             END
                                            ELSE
                                             Smg$Ring_Bell(Display_Id)
                                        ELSE
                                         IF NOT(Horizontal) THEN
                                           IF X > 1 THEN
                                             BEGIN
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Choices_Rendition);
                                               IF (Mark = Half) AND (Maxchs > Height) AND (X > Half) THEN
                                                 BEGIN
                                                   IF Right THEN
                                                     Xm := Width - Choices[X-Half].Length + 1;
                                                   IF Center THEN
                                                     Xm := ((Width - Choices[X-Half].Length) DIV 2) + 1;
                                                   Smg$Scroll_Display_Area(Display_Id, Direction := Smg$M_Down);
                                                   Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X-Half], Cuj$C_Trim), 1, Xm,,,Choices_Rendition);
                                                 END
                                                ELSE
                                                 Mark := Mark - 1;
                                               X := X - 1;
                                               IF Right THEN
                                                 Xm := Width - Choices[X].Length + 1;
                                               IF Center THEN
                                                 Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Selecting_Rendition);
                                             END
                                            ELSE
                                             IF Wrapped THEN
                                               BEGIN
                                                 IF Fixed THEN
                                                   Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition)
                                                  ELSE
                                                   Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Choices_Rendition);
                                                 Mark := Maxchs;
                                                 X := Maxchs;
                                                 Smg$Begin_Display_Update(Display_Id);
                                                 IF Maxchs > Height THEN
                                                   BEGIN
                                                     Mark := Height;
                                                     Smg$Erase_Display(Display_Id);
                                                     REPEAT
                                                       IF Right THEN
                                                         Xm := Width - Choices[X].Length + 1;
                                                       IF Center THEN
                                                         Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                                       Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                       X := X - 1;
                                                       Mark := Mark - 1;
                                                     UNTIL Mark < 1;
                                                     Mark := Height;
                                                     X := Maxchs;
                                                   END;
                                                 IF Right THEN
                                                   Xm := Width - Choices[X].Length + 1;
                                                 IF Center THEN
                                                   Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                                 IF Fixed THEN
                                                   Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                                                  ELSE
                                                   Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Selecting_Rendition);
                                                 Smg$End_Display_Update(Display_Id);
                                               END
                                              ELSE
                                               Smg$Ring_Bell(Display_Id)
                                          ELSE
                                           Smg$Ring_Bell(Display_Id);
                Cuj$Down_Arrow       : IF Blocked THEN
                                         IF False THEN
                                           BEGIN
                                           END
                                          ELSE
                                           IF Wrapped THEN
                                             BEGIN
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                               Mark := 1;
                                               X := (Xm DIV Diff) + 1;
                                               IF More THEN
                                                 BEGIN
                                                   Smg$Begin_Display_Update(Display_Id);
                                                   Smg$Erase_Display(Display_Id);
                                                   Cnt := X - (Xm DIV Diff + 1) + 1;
                                                   Oldx := Xm;
                                                   Xm := 1;
                                                   REPEAT
                                                     REPEAT
                                                       Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[Cnt], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                       Cnt := Cnt + 1;
                                                       Xm := Xm + Diff;
                                                     UNTIL Xm > Max;
                                                     Mark := Mark + 1;
                                                     Xm := 1;
                                                   UNTIL Mark > Height;
                                                   Smg$End_Display_Update(Display_Id);
                                                   Xm := Oldx;
                                                   X := (Xm DIV Diff) + 1;
                                                   Mark := 1;
                                                 END;
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                             END
                                            ELSE
                                             Smg$Ring_Bell(Display_Id)
                                        ELSE
                                         IF NOT(Horizontal) THEN
                                           IF X < Maxchs THEN
                                             BEGIN
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Choices_Rendition);
                                               IF (Mark = Half) AND (Maxchs > Height) AND (X < Maxchs-Half+Remain) THEN
                                                 BEGIN
                                                   IF Right THEN
                                                     Xm := Width - Choices[X+Half+1-Remain].Length + 1;
                                                   IF Center THEN
                                                     Xm := ((Width - Choices[X+Half+1-Remain].Length) DIV 2) + 1;
                                                   Smg$Scroll_Display_Area(Display_Id);
                                                   Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X+Half+1-Remain], Cuj$C_Trim), Height, Xm,,,Choices_Rendition);
                                                 END
                                                ELSE
                                                 Mark := Mark + 1;
                                               X := X + 1;
                                               IF Right THEN
                                                 Xm := Width - Choices[X].Length + 1;
                                               IF Center THEN
                                                 Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Selecting_Rendition);
                                             END
                                            ELSE
                                             IF Wrapped THEN
                                               BEGIN
                                                 IF Fixed THEN
                                                   Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition)
                                                  ELSE
                                                   Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Choices_Rendition);
                                                 Mark := 1;
                                                 X := 1;
                                                 Smg$Begin_Display_Update(Display_Id);
                                                 IF Maxchs > Height THEN
                                                   BEGIN
                                                     Smg$Erase_Display(Display_Id);
                                                     REPEAT
                                                       IF Right THEN
                                                         Xm := Width - Choices[X].Length + 1;
                                                       IF Center THEN
                                                         Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                                       Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X], Cuj$C_Trim), X, Xm,,,Choices_Rendition);
                                                       X := X + 1;
                                                     UNTIL (X > Height) OR (X > Maxchs);
                                                     X := 1;
                                                   END;
                                                 IF Right THEN
                                                   Xm := Width - Choices[X].Length + 1;
                                                 IF Center THEN
                                                   Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                                 IF Fixed THEN
                                                   Smg$Change_Rendition(Display_Id, 1, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                                                  ELSE
                                                   Smg$Change_Rendition(Display_Id, 1, 1, 1, Width,,Selecting_Rendition);
                                                 Smg$End_Display_Update(Display_Id);
                                               END
                                              ELSE
                                               Smg$Ring_Bell(Display_Id)
                                          ELSE
                                           Smg$Ring_Bell(Display_Id);
                Cuj$Left_Arrow       : IF Blocked THEN
                                         IF False THEN
                                           BEGIN
                                           END
                                          ELSE
                                           IF Wrapped THEN
                                             BEGIN
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                               X := Maxchs;
                                               Xm := Wrapx;
                                               Mark := Maxchs DIV Num;
                                               IF Maxchs MOD Num > 0 THEN
                                                 Mark := Mark + 1;
                                               IF More THEN
                                                 BEGIN
                                                   Smg$Begin_Display_Update(Display_Id);
                                                   Smg$Erase_Display(Display_Id);
                                                   Mark := Height;
                                                   Cnt := X;
                                                   REPEAT
                                                     REPEAT
                                                       Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[Cnt], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                       Cnt := Cnt - 1;
                                                       Xm := Xm - Maxwidth - 2;
                                                     UNTIL Xm < 1;
                                                     Xm := Max;
                                                     Mark := Mark - 1;
                                                   UNTIL Mark < 1;
                                                   Smg$End_Display_Update(Display_Id);
                                                   Xm := Wrapx;
                                                   Mark := Height;
                                                 END;
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                             END
                                            ELSE
                                             Smg$Ring_Bell(Display_Id)
                                        ELSE
                                         IF Horizontal THEN
                                           IF X > 1 THEN
                                             BEGIN
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                               Xm := Xm - Maxwidth - 2;
                                               IF Xm < 1 THEN
                                                 BEGIN
                                                   Cnt := X - 1;
                                                   Xm := Max;
                                                   Smg$Begin_Display_Update(Display_Id);
                                                   Smg$Erase_Display(Display_Id, Mark, 1, Mark, Width);
                                                   REPEAT
                                                     Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                     Cnt := Cnt - 1;
                                                     Xm := Xm - Maxwidth - 2;
                                                   UNTIL (Xm < 1) OR (Cnt < 1);
                                                   Smg$End_Display_Update(Display_Id);
                                                   Xm := Max;
                                                 END;
                                               X := X - 1;
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                             END
                                            ELSE
                                             IF Wrapped THEN
                                               BEGIN
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Choices[X].Length,,Choices_Rendition);
                                                 X := Maxchs;
                                                 Xm := Wrapx;
                                                 IF More THEN
                                                   BEGIN
                                                     Cnt := Maxchs;
                                                     Smg$Begin_Display_Update(Display_Id);
                                                     Smg$Erase_Display(Display_Id, Mark, 1, Mark, Width);
                                                     REPEAT
                                                       Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                       Cnt := Cnt - 1;
                                                       Xm := Xm - Maxwidth - 2;
                                                     UNTIL (Xm < 1) OR (Cnt < 1);
                                                     Smg$End_Display_Update(Display_Id);
                                                     Xm := Wrapx;
                                                   END;
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                               END
                                              ELSE
                                               Smg$Ring_Bell(Display_Id)
                                          ELSE
                                           Smg$Ring_Bell(Display_Id);
                 Cuj$Right_Arrow     : IF Blocked THEN
                                         IF False THEN
                                           BEGIN
                                           END
                                          ELSE
                                           IF Wrapped THEN
                                             BEGIN
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                               X := 1;
                                               Mark := 1;
                                               Xm := 1;
                                               IF More THEN
                                                 BEGIN
                                                   Smg$Begin_Display_Update(Display_Id);
                                                   Smg$Erase_Display(Display_Id);
                                                   Cnt := X;
                                                   REPEAT
                                                     REPEAT
                                                       Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[Cnt], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                       Cnt := Cnt + 1;
                                                       Xm := Xm + Diff;
                                                     UNTIL Xm > Max;
                                                     Xm := 1;
                                                     Mark := Mark + 1;
                                                   UNTIL Mark > Height;
                                                   Smg$End_Display_Update(Display_Id);
                                                   Mark := 1;
                                                   Xm := 1;
                                                 END;
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                             END
                                            ELSE
                                             Smg$Ring_Bell(Display_Id)
                                        ELSE
                                         IF Horizontal THEN
                                           IF X < Maxchs THEN
                                             BEGIN
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                               Xm := Xm + Diff;
                                               IF Xm > Max THEN
                                                 BEGIN
                                                   Cnt := X + 1;
                                                   Xm := 1;
                                                   Smg$Begin_Display_Update(Display_Id);
                                                   Smg$Erase_Display(Display_Id, Mark, 1, Mark, Width);
                                                   REPEAT
                                                     Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                     Cnt := Cnt + 1;
                                                     Xm := Xm + Diff;
                                                   UNTIL (Xm > Max) OR (Cnt > Maxchs);
                                                   Smg$End_Display_Update(Display_Id);
                                                   Xm := 1;
                                                 END;
                                               X := X + 1;
                                               Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                             END
                                            ELSE
                                             IF Wrapped THEN
                                               BEGIN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                                 Xm := 1;
                                                 X := 1;
                                                 IF More THEN
                                                   BEGIN
                                                     Cnt := 1;
                                                     Smg$Begin_Display_Update(Display_Id);
                                                     Smg$Erase_Display(Display_Id, Mark, 1, Mark, Width);
                                                     REPEAT
                                                       Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                       Cnt := Cnt + 1;
                                                       Xm := Xm + Diff;
                                                     UNTIL (Xm > Max) OR (Cnt > Maxchs);
                                                     Smg$End_Display_Update(Display_Id);
                                                     Xm := 1;
                                                   END;
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Choices[X].Length,,Selecting_Rendition);
                                               END
                                              ELSE
                                               Smg$Ring_Bell(Display_Id)
                                          ELSE
                                           Smg$Ring_Bell(Display_Id);
                Cuj$Prev_Scrn        : IF (X = 1) AND Wrapped OR (X > 1) THEN
                                         IF Blocked THEN
                                           BEGIN
                                           END
                                          ELSE
                                           IF NOT(Horizontal) THEN
                                             BEGIN
                                               IF Updated THEN
                                                 Smg$Begin_Display_Update(Display_Id);
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Choices_Rendition);
                                               Step := X - Height;
                                               REPEAT
                                                 IF (Mark = Half) AND (Maxchs > Height) AND (X > Half) THEN
                                                   BEGIN
                                                     IF Right THEN
                                                       Xm := Width - Choices[X-Half].Length + 1;
                                                     IF Center THEN
                                                       Xm := ((Width - Choices[X-Half].Length) DIV 2) + 1;
                                                     Smg$Scroll_Display_Area(Display_Id, Direction := Smg$M_Down);
                                                     Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X-Half], Cuj$C_Trim), 1, Xm,,,Choices_Rendition);
                                                   END
                                                  ELSE
                                                   Mark := Mark - 1;
                                                 X := X - 1;
                                               UNTIL (X < 1) OR (X = Step);
                                               IF (X < 1) AND Wrapped THEN
                                                 BEGIN
                                                   IF Maxchs > Height THEN
                                                     BEGIN
                                                       Smg$Begin_Display_Update(Display_Id);
                                                       Smg$Erase_Display(Display_Id);
                                                       Mark := Height;
                                                       X := Maxchs;
                                                       REPEAT
                                                         IF Right THEN
                                                           Xm := Width - Choices[X].Length + 1;
                                                         IF Center THEN
                                                           Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                                         Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                         Mark := Mark - 1;
                                                         X := X - 1;
                                                       UNTIL Mark < 1;
                                                       Smg$End_Display_Update(Display_Id);
                                                       Mark := Height;
                                                     END
                                                    ELSE
                                                     Mark := Maxchs;
                                                   X := Maxchs;
                                                 END
                                                ELSE
                                                 IF X < 1 THEN
                                                   BEGIN
                                                     Mark := 1;
                                                     X := 1;
                                                   END;
                                               IF Right THEN
                                                 Xm := Width - Choices[X].Length + 1;
                                               IF Center THEN
                                                 Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Selecting_Rendition);
                                               IF Updated THEN
                                                 Smg$End_Display_Update(Display_Id);
                                             END
                                            ELSE
                                             IF (X-Num >= 1) AND More THEN
                                               BEGIN
                                                 Smg$Begin_Display_Update(Display_Id);
                                                 Smg$Erase_Display(Display_Id);
                                                 X := X - Num;
                                                 Oldx := Xm;
                                                 Cnt := X - (Xm DIV Diff + 1) + 1;
                                                 Xm := 1;
                                                 Step := Cnt + Num - 1;
                                                 REPEAT
                                                   Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                   Cnt := Cnt + 1;
                                                   Xm := Xm + Diff;
                                                 UNTIL (Cnt > Step) OR (Cnt > Maxchs);
                                                 Smg$End_Display_Update(Display_Id);
                                                 Xm := Oldx;
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                               END
                                              ELSE
                                               IF Wrapped THEN
                                                 BEGIN
                                                   Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                                   X := Maxchs;
                                                   Xm := Wrapx;
                                                   IF More THEN
                                                     BEGIN
                                                       Cnt := Maxchs;
                                                       Smg$Begin_Display_Update(Display_Id);
                                                       Smg$Erase_Display(Display_Id);
                                                       REPEAT
                                                         Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                         Cnt := Cnt - 1;
                                                         Xm := Xm - Maxwidth - 2;
                                                       UNTIL (Xm < 1) OR (Cnt < 1);
                                                       Smg$End_Display_Update(Display_Id);
                                                       Xm := Wrapx;
                                                     END;
                                                   Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                                 END
                                                ELSE
                                                 Smg$Ring_Bell(Display_Id)
                                        ELSE
                                         Smg$Ring_Bell(Display_Id);
                Cuj$Next_Scrn        : IF (X = Maxchs) AND Wrapped OR (X < Maxchs) THEN
                                         IF Blocked THEN
                                           BEGIN
                                           END
                                          ELSE
                                           IF NOT(Horizontal) THEN
                                             BEGIN
                                               IF Updated THEN
                                                 Smg$Begin_Display_Update(Display_Id);
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Choices_Rendition);
                                               Step := X + Height;
                                               REPEAT
                                                 IF (Mark = Half) AND (Maxchs > Height) AND (X < Maxchs-Half+Remain) THEN
                                                   BEGIN
                                                     IF Right THEN
                                                       Xm := Width - Choices[X+Half+1-Remain].Length + 1;
                                                     IF Center THEN
                                                       Xm := ((Width - Choices[X+Half+1-Remain].Length) DIV 2) + 1;
                                                     Smg$Scroll_Display_Area(Display_Id);
                                                     Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X+Half+1-Remain], Cuj$C_Trim), Height, Xm,,,Choices_Rendition);
                                                   END
                                                  ELSE
                                                   Mark := Mark + 1;
                                                 X := X + 1;
                                               UNTIL (X > Maxchs) OR (X = Step);
                                               IF (X > Maxchs) AND Wrapped THEN
                                                 BEGIN
                                                   IF Maxchs > Height THEN
                                                     BEGIN
                                                       Smg$Begin_Display_Update(Display_Id);
                                                       Smg$Erase_Display(Display_Id);
                                                       Mark := 1;
                                                       X := 1;
                                                       REPEAT
                                                         IF Right THEN
                                                           Xm := Width - Choices[X].Length + 1;
                                                         IF Center THEN
                                                           Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                                         Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[X], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                         Mark := Mark + 1;
                                                         X := X + 1;
                                                       UNTIL Mark > Height;
                                                       Smg$End_Display_Update(Display_Id);
                                                     END;
                                                   Mark := 1;
                                                   X := 1;
                                                 END
                                                ELSE
                                                 IF X > Maxchs THEN
                                                   BEGIN
                                                     Mark := Height;
                                                     X := Maxchs;
                                                   END;
                                               IF Right THEN
                                                 Xm := Width - Choices[X].Length + 1;
                                               IF Center THEN
                                                 Xm := ((Width - Choices[X].Length) DIV 2) + 1;
                                               IF Fixed THEN
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition)
                                                ELSE
                                                 Smg$Change_Rendition(Display_Id, Mark, 1, 1, Width,,Selecting_Rendition);
                                               IF Updated THEN
                                                 Smg$End_Display_Update(Display_Id);
                                             END
                                            ELSE
                                             IF More AND (X+Num <= Maxchs) THEN
                                               BEGIN
                                                 Smg$Begin_Display_Update(Display_Id);
                                                 Smg$Erase_Display(Display_Id);
                                                 X := X + Num;
                                                 Oldx := Xm;
                                                 Cnt := X - (Xm DIV Diff + 1) + 1;
                                                 Xm := 1;
                                                 Step := Cnt + Num - 1;
                                                 REPEAT
                                                   Smg$Put_Chars(Display_Id, Cuj$Edit(Choices[Cnt], Cuj$C_Trim), Mark, Xm,,,Choices_Rendition);
                                                   Cnt := Cnt + 1;
                                                   Xm := Xm + Diff;
                                                 UNTIL (Cnt > Step) OR (Cnt > Maxchs);
                                                 Smg$End_Display_Update(Display_Id);
                                                 IF X = Maxchs THEN
                                                   Xm := Wrapx
                                                  ELSE
                                                   Xm := Oldx;
                                                 Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Selecting_Rendition);
                                               END
                                              ELSE
                                               IF Wrapped THEN
                                                 BEGIN
                                                   Smg$Change_Rendition(Display_Id, Mark, Xm, 1, Choices[X].Length,,Choices_Rendition);
                                                   X := 1;
                                                   Xm := 1;
                                                   IF More THEN
                                                     BEGIN
                                                       Smg$Begin_Display_Update(Display_Id);
                                                       Smg$Erase_Display(Display_Id);
                                                       Cnt := X;
                                                       Step := Cnt + Num - 1;
                                                       REPEAT
                                                         Smg$Put_Chars(Display_Id, Choices[Cnt], Mark, Xm,,,Choices_Rendition);
                                                         Cnt := Cnt + 1;
                                                         Xm := Xm + Diff;
                                                       UNTIL (Cnt > Step) OR (Cnt > Maxchs);
                                                       Smg$End_Display_Update(Display_Id);
                                                       Xm := 1;
                                                     END;
                                                   Smg$Change_Rendition(Display_Id, Mark, 1, Xm, Choices[X].Length,,Selecting_Rendition);
                                                 END
                                                ELSE
                                                 Smg$Ring_Bell(Display_Id)
                                        ELSE
                                         Smg$Ring_Bell(Display_Id);
              END;
              Smg$Set_Cursor_Abs(Display_Id, Mark, Xm);
            UNTIL Index(Terminators, Chr(Keyword)) > 0;
            Resultant_Position := X;
            IF Chr(Keyword) = Terminators[1] THEN
              Selected_Choice := Choices[X]
             ELSE
              Selected_Choice := Chr(0);
            Return_Value := Keyword;
            Cuj$Menu := True;
          END;
      END;
  END; { Cuj$Menu }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                 CUJ$OMIT                                  *)
(*                                                                           *)
(*   This function will omit a string from a text string.  If the string to  *)
(* omit is not found, CUJ$OMIT will return the original text string.         *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Omit(Text_String : VARYING [$L] OF Char;
                  Omission_String : VARYING [$L2] OF Char;
                  Omission_Interval : Cuj$Uword := 1) : Cuj$Varying2000;

  VAR
    X, Idx,
    Cnt     : [Automatic] Integer;
    Tmp     : [Automatic] Cuj$Varying2000;

  BEGIN
    Idx := Index(Text_String, Omission_String);
    IF Idx = 0 THEN
      Cuj$Omit := Text_String
     ELSE
      BEGIN
        Cnt := 1;
        REPEAT
          Tmp := '';
          FOR X := 1 TO Idx-1 DO
            Tmp := Tmp + Text_String.Body[X];
          FOR X := Idx+Omission_String.Length TO Text_String.Length DO
            Tmp := Tmp + Text_String.Body[X];
          Text_String := Tmp;
          Idx := Index(Text_String, Omission_String);
          Cnt := Cnt + 1;
        UNTIL (Idx = 0) OR (Cnt > Omission_Interval);
        Cuj$Omit := Text_String;
      END;
  END; { Cuj$Omit }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                              CUJ$PUT_STRING                               *)
(*                                                                           *)
(*   This function will put a specified text string onto a virtual display,  *)
(* depending on the flag(s) passed to it.                                    *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Put_String(Display_Id : [Volatile] Unsigned;
                        Text_String : VARYING [$L] OF Char;
                        Display_Row, Display_Column : Integer := 1;
                        Character_Rendition : Unsigned := Smg$M_Normal;
                        Flags : Integer := Cuj$C_Normal) : Cuj$Bit;

  VAR
    X, Cnt, Idx,
    Height, Width  : [Static] Integer;
    Temp           : [Static] Cuj$Varying2000;
    Center_Row,
    Center_Column,
    Vertical       : [Static] Cuj$Bit;

  BEGIN
    Smg$Get_Display_Attr(Display_Id, Height, Width);
    Center_Row := False;
    Center_Column := False;
    Vertical := False;
    Cnt := 1;
    FOR X := 0 TO 5 DO
      BEGIN
        IF (Flags MOD 2) = 1 THEN
          CASE Cnt OF
            Cuj$C_Center        : BEGIN
                                    Display_Row := Round(Height/2);
                                    Display_Column := Round(((Width+1)-Text_String.Length)/2);
                                    Center_Row := True;
                                    Center_Column := True;
                                  END;
            Cuj$C_Center_Row    : BEGIN
                                    Display_Row := Round(Height/2);
                                    Center_Row := True;
                                  END;
            Cuj$C_Center_Column : BEGIN
                                    Display_Column := Round(((Width+1)-Text_String.Length)/2);
                                    Center_Column := True;
                                  END;
            Cuj$C_Right_Flush   : Display_Column := Width - Text_String.Length + 1;
            Cuj$C_Backwards     : BEGIN
                                    Temp := '';
                                    FOR Idx := Text_String.Length DOWNTO 1 DO
                                      Temp := Temp + Text_String.Body[Idx];
                                    Text_String := Substr(Temp, 1, Temp.Length);
                                  END;
            Cuj$C_Vertical      : BEGIN
                                    IF Center_Row THEN
                                      Display_Row := Round(((Height+1)-Text_String.Length)/2);
                                    IF Center_Column THEN
                                      Display_Column := Round(Width/2);
                                    Vertical := True;
                                  END;
          END;
        Flags := Flags DIV 2;
        Cnt := Cnt * 2;
      END;
    IF NOT(Vertical) THEN
      Smg$Put_Chars(Display_Id, Substr(Text_String, 1, Text_String.Length), Display_Row, Display_Column,,,Character_Rendition)
     ELSE
      BEGIN
        X := 1;
        Cnt := Display_Row;
        REPEAT
          Smg$Put_Chars(Display_Id, Text_String.Body[X], Cnt, Display_Column,,,Character_Rendition);
          X := X + 1;
          Cnt := Cnt + 1;
        UNTIL (X > Text_String.Length) OR (Cnt > Height);
      END;
    Cuj$Put_String := True;
  END; { Cuj$Put_String }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                 CUJ$REAL                                  *)
(*                                                                           *)
(*   This function will convert a string into a real number.                 *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Real(Text_String : VARYING [$L] OF Char) : Real;

  VAR
    Idx, Ex,
    X, Num   : [Automatic] Integer;
    Total,
    Remain   : [Automatic] Real;
    Negative : [Automatic] Cuj$Bit;

  BEGIN
    Num := 0;
    Remain := 0.0;
    Negative := Index(Text_String, '-') > 0;
    Idx := Index(Text_String, '.');
    Ex := 10;
    IF Idx = 1 THEN
      Cuj$Real := 0.0
     ELSE
      BEGIN
        IF Idx > 1 THEN
          BEGIN 
            FOR X := Idx+1 TO Text_String.Length DO
              IF Text_String.Body[X] IN ['0'..'9'] THEN
                BEGIN
                  Remain := Remain + ((Ord(Text_String.Body[X]) - 48) / Ex);
                  Ex := Ex * 10;
                END;
            Idx := Idx - 1;
          END
         ELSE
          Idx := Text_String.Length;
        FOR X := 1 TO Idx DO
          IF Text_String.Body[X] IN ['0'..'9'] THEN
            Num := (Num * 10) + Ord(Text_String.Body[X]) - 48;
        Total := Num + Remain;
        IF Negative THEN
          Total := -Total;
        Cuj$Real := Total;
      END;
  END; { Cuj$Real }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$REAL_STRING                               *)
(*                                                                           *)
(*   This function will convert a real number into a string.                 *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Real_String(Number : Real) : Cuj$Varying255;

  VAR
    Tmp, Tmp2 : [Automatic] Cuj$Varying255;
    X, Num,
    Expo      : [Automatic] Integer;
    Remain    : [Automatic] Real;
 
  BEGIN
    Tmp := '';
    Tmp2 := '';
    IF Number < 0.0 THEN
      Tmp2 := Tmp2 + '-';
    Num := Abs(Trunc(Number) DIV 1);
    Remain := Abs(Number-Num);
    REPEAT
      Tmp := Tmp + Chr((Num MOD 10)+48);
      Num := Num DIV 10;
    UNTIL Num = 0;
    FOR X := Tmp.Length DOWNTO 1 DO
      Tmp2 := Tmp2 + Tmp.Body[X];
    Tmp2 := Tmp2 + '.';
    Tmp := '';
    X := 0;
    Expo := 10;
    REPEAT
      Num := Trunc(Remain*Expo) - X;
      Tmp := Tmp + Chr(Num+48);
      X := Trunc(Remain*Expo) * 10;
      Expo := Expo * 10;
    UNTIL Trunc(Remain*Expo) = X;
    Tmp2 := Tmp2 + Tmp;
    Cuj$Real_String := Tmp2;
  END; { Cuj$Real_String }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                           CUJ$REMOVE_RECTANGLE                            *)
(*                                                                           *)
(*   This function will remove a rectangle that was drawn by the RTL routine *)
(* SMG$DRAW_RECTANGLE.                                                       *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Remove_Rectangle(Display_Id : [Volatile] Unsigned;
                              Start_Row, Start_Column, End_Row, End_Column : Integer := 1) : Cuj$Bit;

  BEGIN
    Smg$Begin_Display_Update(Display_Id);
    Smg$Remove_Line(Display_Id, Start_Row, Start_Column, Start_Row, End_Column);
    Smg$Remove_Line(Display_Id, Start_Row, End_Column, End_Row, End_Column);
    Smg$Remove_Line(Display_Id, Start_Row, Start_Column, End_Row, Start_Column);
    Smg$Remove_Line(Display_Id, End_Row, Start_Column, End_Row, End_Column);
    Smg$End_Display_Update(Display_Id);
    Cuj$Remove_Rectangle := True;
  END; { Cuj$Remove_Rectangle }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                            CUJ$ROTATE_DISPLAY                             *)
(*                                                                           *)
(*   This function will rotate a specified virtual display.  To obtain the   *)
(* best results, the display should have equal dimensions unless the display *)
(* is being rotated 180 degrees.                                             *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Rotate_Display(Display_Id : [Volatile] Unsigned;
                            Degrees : Unsigned := Cuj$C_90_Degrees;
                            Direction : Unsigned := Cuj$C_Right;
                            Flag : Unsigned := Cuj$C_Normal) : Cuj$Bit;

  VAR
    Temp   : [Automatic] ARRAY [1..255] OF Cuj$Packed255;
    X, X2,
    Width,
    Height : [Automatic] Integer;

  BEGIN
    Smg$Get_Display_Attr(Display_Id, Height, Width);
    IF Flag = Cuj$C_Update THEN
      Smg$Begin_Display_Update(Display_Id);
    FOR X := 1 TO Height DO
      Smg$Read_From_Display(Display_Id, Temp[X],,X);
    IF (Height <> Width) AND (Degrees <> Cuj$C_180_Degrees) THEN
      Smg$Change_Virtual_Display(Display_Id, Width, Height);
    FOR X := 1 TO Height DO
      FOR X2 := 1 TO Width DO
        IF Degrees <> Cuj$C_180_Degrees THEN
          BEGIN
            CASE Temp[X,X2] OF
              '-' : Temp[X,X2] := '|';
              '|' : Temp[X,X2] := '-';
              '/' : Temp[X,X2] := '\';
              '\' : Temp[X,X2] := '/';
              '=' : Temp[X,X2] := '"';
              '"' : Temp[X,X2] := '=';
            END;
            IF Direction = Cuj$C_Left THEN
              Smg$Put_Chars(Display_Id, Temp[X,X2], Width+1-X2, X)
             ELSE
              Smg$Put_Chars(Display_Id, Temp[X,X2], X2, Height+1-X);
          END
         ELSE
          BEGIN
            CASE Temp[X,X2] OF
              '{'      : Temp[X,X2] := '}';
              '}'      : Temp[X,X2] := '{';
              '['      : Temp[X,X2] := ']';
              ']'      : Temp[X,X2] := '[';
              '('      : Temp[X,X2] := ')';
              ')'      : Temp[X,X2] := '(';
              '<'      : Temp[X,X2] := '>';
              '>'      : Temp[X,X2] := '<';
              ''''     : Temp[X,X2] := '`';
              '`'      : Temp[X,X2] := '''';
              '?'      : Temp[X,X2] := Chr(191);
              Chr(191) : Temp[X,X2] := '?';
            END;
            Smg$Put_Chars(Display_Id, Temp[X,X2], Height+1-X, Width+1-X2);
          END;
    IF Flag = Cuj$C_Update THEN
      Smg$End_Display_Update(Display_Id);
    Cuj$Rotate_Display := True;
  END; { Cuj$Rotate_Display }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                        CUJ$SET_DEFAULT_DIRECTORY                          *)
(*                                                                           *)
(*   This function will set a user to a default directory.                   *)
(*                                                                           *)

[Asynchronous,External(Sys$Setddir)]
FUNCTION Cuj$Set_Default_Directory(New_Directory : [Class_S] PACKED ARRAY [$A..$B:Integer] OF Char := %IMMED 0;
                                   VAR Directory_Length : Cuj$Uword := %IMMED 0;
                                   VAR Current_Directory : [Class_S] PACKED ARRAY [$C..$D:Integer] OF Char := %IMMED 0) : Integer; External;

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                        CUJ$SET_DEFAULT_PROTECTION                         *)
(*                                                                           *)
(*   This function will set the default file protection to the bit mask that *)
(* is passed into it.  This function is similar to the DCL command SET PRO-  *)
(* TECTION/DEFAULT.                                                          *)
(*                                                                           *)

[Asynchronous,External(Sys$Setdfprot)]
FUNCTION Cuj$Set_Default_Protection(New_Protection : [Volatile] Cuj$Uword := %IMMED 0;
                                    VAR Current_Protection : [Volatile] Cuj$Uword := %IMMED 0) : Integer; External;

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                            CUJ$SET_FILE_PROT                              *)
(*                                                                           *)
(*   This function will set a specified file to the protection passed in by  *)
(* the user.  CUJ$SET_FILE_PROT will return FALSE if it could not set the    *)
(* protection on the file.                                                   *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Set_File_Prot(Filename : [Volatile] VARYING [$L] OF Char;
                           Prot_Mask : [Volatile] Cuj$Prot_Type) : Cuj$Bit;

  TYPE
    Protmask = RECORD
                 CASE Boolean OF
                   True  : (Mask  : Cuj$Prot_Type);
                   False : (Dummy : Cuj$Uword);
               END;

  VAR
    Fabblk : [Static] Fab$Type;
    Xabblk : [Static] Xab$Type;
    Prot   : [Static] Protmask;
    X,
    Stat2  : [Automatic] Integer;

  BEGIN
    FOR X := 1 TO Filename.Length DO
      IF Filename.Body[X] IN ['a'..'z'] THEN
        Filename.Body[X] := Chr(Ord(Filename.Body[X])-32);
    Fabblk.Fab$B_Bid := Fab$C_Bid;
    Fabblk.Fab$B_Bln := Fab$C_Bln;
    Fabblk.Fab$B_Fac := Fab$M_Upd;
    Fabblk.Fab$B_Fns := Filename.Length;
    Fabblk.Fab$L_Fna := Iaddress(Filename.Body);
    Fabblk.Fab$L_Xab := Iaddress(Xabblk);
    Xabblk.Xab$B_Cod := Xab$C_Pro;
    Xabblk.Xab$B_Bln := Xab$C_Prolen;
    Xabblk.Xab$L_Nxt := 0;
    Stat := $Open(%REF Fabblk);
    Prot.Dummy := Xabblk.Xab$W_Pro;
    Prot.Mask := Prot_Mask;
    Xabblk.Xab$W_Pro := Prot.Dummy;
    Stat2 := $Close(%REF Fabblk);
    Cuj$Set_File_Prot := Odd(Stat) AND Odd(Stat2);
  END; { Cuj$Set_File_Prot }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                               CUJ$SET_TABS                                *)
(*                                                                           *)
(*   This function will set the terminal's tab positions.                    *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Set_Tabs(Starting_Position : Cuj$Uword := 9;
                      Number_Of_Columns : Cuj$Uword := 80;
                      Interval : Cuj$Uword := 8) : Cuj$Bit;

  VAR
    X : [Automatic] Integer;

  BEGIN
    Lib$Put_Output(Cuj$Escape+'[3g');
    X := Starting_Position;
    REPEAT
      Lib$Put_Output(Cuj$Escape+'[1;'+Udec(X,3)+'H'+Cuj$Escape+'H');
      X := X + Interval;
    UNTIL X > Number_Of_Columns;
    Cuj$Set_Tabs := True;
  END; { Cuj$Set_Tabs }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                          CUJ$SET_TERMINAL_MODE                            *)
(*                                                                           *)
(*   This function will set the terminal into the mode(s) passed into it.    *)
(* CUJ$SET_TERMINAL_MODE will return FALSE if the mode(s) could not be set.  *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Set_Terminal_Mode(Device : VARYING [$L] OF Char := 'TT';
                               Attributes : Unsigned;
                               Flag : Integer := Cuj$C_Enable) : Cuj$Bit;

  VAR
    Chn : [Automatic] Cuj$Uword;
    Ch  : [Automatic] ARRAY [1..2] OF Unsigned;

  BEGIN
    Stat := $Assign(Device, Chn);
    IF NOT(Odd(Stat)) THEN
      Cuj$Set_Terminal_Mode := False
     ELSE
      BEGIN
        Stat := $Qio(Chan := Chn, Func := Io$_Sensemode, P1 := Ch, P2 := 8);
        IF NOT(Odd(Stat)) THEN
          Cuj$Set_Terminal_Mode := False
         ELSE
          BEGIN
            CASE Flag OF
              Cuj$C_Disable : BEGIN
                                Ch[2] := Uor(Ch[2], Attributes);
                                $Qio(Chan := Chn, Func := Io$_Setmode, P1 := Ch, P2 := 8);
                                Ch[2] := Uxor(Ch[2], Attributes);
                              END;
              Cuj$C_Enable  : Ch[2] := Uor(Ch[2], Attributes);
              Cuj$C_Toggle  : Ch[2] := Uxor(Ch[2], Attributes);
            END;
            Stat := $Qio(Chan := Chn, Func := Io$_Setmode, P1 := Ch, P2 := 8);
            Cuj$Set_Terminal_Mode := Odd(Stat);
          END;
      END;
  END; { Cuj$Set_Terminal_Mode }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                CUJ$STRING                                 *)
(*                                                                           *)
(*   This function will convert an integer to a string.  CUJ$STRING will re- *)
(* turn the resultant string.  This is similar to the DCL lexical function   *)
(* F$STRING.                                                                 *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$String(Number : [Unsafe] Integer) : Cuj$Varying255;

  VAR
    X        : [Automatic] Integer;
    Tmp      : [Automatic] Cuj$Varying255;
    Ch       : [Automatic] Char;
    Negative : [Automatic] Cuj$Bit;

  BEGIN
    Tmp := '';
    Negative := False;
    IF Number = 0 THEN
      Tmp := Tmp + '0'
     ELSE
      BEGIN
        IF Number < 0 THEN
          BEGIN
            Number := Abs(Number);
            Negative := True;
          END;
         WHILE Number <> 0 DO
           BEGIN
             Tmp := Tmp + Chr((Number MOD 10) + 48);
             Number := Number DIV 10;
           END;
         IF Negative THEN
           Tmp := Tmp + '-';
         FOR X := 1 TO (Tmp.Length DIV 2) DO
           BEGIN
             Ch := Tmp.Body[X];
             Tmp.Body[X] := Tmp.Body[Tmp.Length-X+1];
             Tmp.Body[Tmp.Length-X+1] := Ch;
           END;
      END;
    Cuj$String := Tmp;
  END; { Cuj$String }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                                CUJ$SUBSTR                                 *)
(*                                                                           *)
(*   This function will extract an expression from a specified string.       *)
(* CUJ$SUBSTR is similar to the predeclared VAX Pascal function SUBSTR and   *)
(* the DCL lexical function F$EXTRACT.  CUJ$SUBSTR returns the extracted ex- *)
(* pression.                                                                 *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Substr(Text_String : VARYING [$L] OF Char;
                    Starting_Position, Number_Of_Characters : Cuj$Uword := 1) : Cuj$Varying512;

  VAR
    Ix     : [Static] Integer;
    Retstr : [Static] Cuj$Varying512;

  BEGIN
    Retstr := '';
    Ix := Starting_Position;
    REPEAT
      IF (Ix <= Text_String.Length) AND (Ix > 0) THEN
        Retstr := Retstr + Text_String.Body[Ix];
      Ix := Ix + 1;
    UNTIL (Ix = 0) OR (Ix > Text_String.Length) OR (Ix > Starting_Position+Number_Of_Characters-1);
    Cuj$Substr := Retstr;
  END; { Cuj$Substr }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                             CUJ$TERMINAL_TYPE                             *)
(*                                                                           *)
(*   This function will return the numeric value of a terminal's current     *)
(* mode.  This has been provided by Peter C. Conover.                        *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Terminal_Type(Device : VARYING [$L] OF Char) : Integer;

  VAR
    X        : [Automatic] Integer;
    Itemlist : [Automatic]
               RECORD
                 Buflen,
                 Itemcode : Cuj$Uword;
                 Bufadr   : ^Integer;
                 Retlen   : ^Cuj$Uword;
                 Term     : Integer;
               END;

  BEGIN
    Itemlist.Term := 0;
    Itemlist.Buflen := 4;
    Itemlist.Itemcode := Dvi$_Devtype;
    New(Itemlist.Bufadr);
    New(Itemlist.Retlen);
    $Getdviw(,,Device, Itemlist);
    X := Itemlist.Bufadr^;
    Dispose(Itemlist.Bufadr);
    Dispose(Itemlist.Retlen);
    Cuj$Terminal_Type := X;
  END; { Cuj$Terminal_Type }

{-----------------------------------------------------------------------------}

(*                                                                           *)
(*                           CUJ$TRANSLATE_LOGICAL                           *)
(*                                                                           *)
(*   This function will translate a specified logical name in a logical ta-  *)
(* ble.  CUJ$TRANSLATE_LOGICAL will return FALSE if the logical does not ex- *)
(* ist in the specified logical table.  This has been provided by Peter C.   *)
(* Conover.                                                                  *)
(*                                                                           *)

[Asynchronous]
FUNCTION Cuj$Translate_Logical(Logical_Name : VARYING [$L] OF Char;
                               Logical_Table : VARYING [$L2] OF Char := Cuj$T_Process;
                               VAR Translation : [Volatile] VARYING [$L3] OF Char) : Cuj$Bit;

  VAR
    Lnm  : [Automatic] Cuj$Varying255;
    List : [Automatic]
           RECORD
             Buflen,
             Itmcod  : Cuj$Uword;
             Bufadr,
             Lenadr,
             Termin  : Unsigned;
           END;

  BEGIN
    Lnm := '';
    List.Buflen := Lnm$C_Namlength;
    List.Itmcod := Lnm$_String;
    List.Bufadr := Iaddress(Lnm.Body);
    List.Lenadr := Iaddress(Lnm.Length);
    List.Termin := 0;
    Stat := $Trnlnm(Attr := Lnm$M_Case_Blind, Tabnam := Logical_Table, Lognam := Logical_Name, Itmlst := List);
    Translation := Lnm;
    Cuj$Translate_Logical := Odd(Stat);
  END; { Cuj$Translate_Logical }

{-----------------------------------------------------------------------------}

END.
